#ifndef _H_BA6CC8CE923DD5619388F0A2CCE8AECB_AccelAuxRpt__H_
#define _H_BA6CC8CE923DD5619388F0A2CCE8AECB_AccelAuxRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AccelAuxRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double raw_pedal_pos_;
                ::DDS::Boolean raw_pedal_pos_is_valid_;
                ::DDS::Double raw_pedal_force_;
                ::DDS::Boolean raw_pedal_force_is_valid_;
                ::DDS::Boolean user_interaction_;
                ::DDS::Boolean user_interaction_is_valid_;
                ::DDS::Boolean brake_interlock_active_;
                ::DDS::Boolean brake_interlock_active_is_valid_;
            };

            typedef DDS_DCPSStruct_var<AccelAuxRpt_> AccelAuxRpt__var;
            typedef DDS_DCPSStruct_out < AccelAuxRpt_> AccelAuxRpt__out;

        }

    }

}

#endif /* _H_BA6CC8CE923DD5619388F0A2CCE8AECB_AccelAuxRpt__H_ */
