#ifndef _H_BA6CC8CE923DD5619388F0A2CCE8AECB_AccelAuxRpt_DCPS_H_
#define _H_BA6CC8CE923DD5619388F0A2CCE8AECB_AccelAuxRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AccelAuxRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AccelAuxRpt_TypeSupportInterface;

            typedef AccelAuxRpt_TypeSupportInterface * AccelAuxRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AccelAuxRpt_TypeSupportInterface> AccelAuxRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AccelAuxRpt_TypeSupportInterface> AccelAuxRpt_TypeSupportInterface_out;


            class AccelAuxRpt_DataWriter;

            typedef AccelAuxRpt_DataWriter * AccelAuxRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AccelAuxRpt_DataWriter> AccelAuxRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < AccelAuxRpt_DataWriter> AccelAuxRpt_DataWriter_out;


            class AccelAuxRpt_DataReader;

            typedef AccelAuxRpt_DataReader * AccelAuxRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AccelAuxRpt_DataReader> AccelAuxRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < AccelAuxRpt_DataReader> AccelAuxRpt_DataReader_out;


            class AccelAuxRpt_DataReaderView;

            typedef AccelAuxRpt_DataReaderView * AccelAuxRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AccelAuxRpt_DataReaderView> AccelAuxRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AccelAuxRpt_DataReaderView> AccelAuxRpt_DataReaderView_out;

            struct AccelAuxRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AccelAuxRpt_, struct AccelAuxRpt_Seq_uniq_> AccelAuxRpt_Seq;
            typedef DDS_DCPSSequence_var < AccelAuxRpt_Seq> AccelAuxRpt_Seq_var;
            typedef DDS_DCPSSequence_out < AccelAuxRpt_Seq> AccelAuxRpt_Seq_out;

            class  AccelAuxRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AccelAuxRpt_TypeSupportInterface_ptr _ptr_type;
                typedef AccelAuxRpt_TypeSupportInterface_var _var_type;

                static AccelAuxRpt_TypeSupportInterface_ptr _duplicate (AccelAuxRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AccelAuxRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AccelAuxRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AccelAuxRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AccelAuxRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AccelAuxRpt_TypeSupportInterface () {};
                ~AccelAuxRpt_TypeSupportInterface () {};
            private:
                AccelAuxRpt_TypeSupportInterface (const AccelAuxRpt_TypeSupportInterface &);
                AccelAuxRpt_TypeSupportInterface & operator = (const AccelAuxRpt_TypeSupportInterface &);
            };

            class  AccelAuxRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AccelAuxRpt_DataWriter_ptr _ptr_type;
                typedef AccelAuxRpt_DataWriter_var _var_type;

                static AccelAuxRpt_DataWriter_ptr _duplicate (AccelAuxRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AccelAuxRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AccelAuxRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AccelAuxRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AccelAuxRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AccelAuxRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AccelAuxRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AccelAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AccelAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AccelAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AccelAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AccelAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AccelAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AccelAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AccelAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AccelAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AccelAuxRpt_& instance_data) = 0;

            protected:
                AccelAuxRpt_DataWriter () {};
                ~AccelAuxRpt_DataWriter () {};
            private:
                AccelAuxRpt_DataWriter (const AccelAuxRpt_DataWriter &);
                AccelAuxRpt_DataWriter & operator = (const AccelAuxRpt_DataWriter &);
            };

            class  AccelAuxRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AccelAuxRpt_DataReader_ptr _ptr_type;
                typedef AccelAuxRpt_DataReader_var _var_type;

                static AccelAuxRpt_DataReader_ptr _duplicate (AccelAuxRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AccelAuxRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AccelAuxRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AccelAuxRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AccelAuxRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AccelAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AccelAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AccelAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AccelAuxRpt_& instance) = 0;

            protected:
                AccelAuxRpt_DataReader () {};
                ~AccelAuxRpt_DataReader () {};
            private:
                AccelAuxRpt_DataReader (const AccelAuxRpt_DataReader &);
                AccelAuxRpt_DataReader & operator = (const AccelAuxRpt_DataReader &);
            };

            class  AccelAuxRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AccelAuxRpt_DataReaderView_ptr _ptr_type;
                typedef AccelAuxRpt_DataReaderView_var _var_type;

                static AccelAuxRpt_DataReaderView_ptr _duplicate (AccelAuxRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AccelAuxRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AccelAuxRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AccelAuxRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AccelAuxRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AccelAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AccelAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AccelAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AccelAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AccelAuxRpt_& instance) = 0;

            protected:
                AccelAuxRpt_DataReaderView () {};
                ~AccelAuxRpt_DataReaderView () {};
            private:
                AccelAuxRpt_DataReaderView (const AccelAuxRpt_DataReaderView &);
                AccelAuxRpt_DataReaderView & operator = (const AccelAuxRpt_DataReaderView &);
            };
        }

    }

}

#endif
