#ifndef _H_B120394884D6EA43F500A7C72AD27CB7_BrakeAuxRpt__H_
#define _H_B120394884D6EA43F500A7C72AD27CB7_BrakeAuxRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  BrakeAuxRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double raw_pedal_pos_;
                ::DDS::Boolean raw_pedal_pos_is_valid_;
                ::DDS::Double raw_pedal_force_;
                ::DDS::Boolean raw_pedal_force_is_valid_;
                ::DDS::Double raw_brake_pressure_;
                ::DDS::Boolean raw_brake_pressure_is_valid_;
                ::DDS::Boolean brake_on_off_;
                ::DDS::Boolean brake_on_off_is_valid_;
                ::DDS::Boolean user_interaction_;
                ::DDS::Boolean user_interaction_is_valid_;
            };

            typedef DDS_DCPSStruct_var<BrakeAuxRpt_> BrakeAuxRpt__var;
            typedef DDS_DCPSStruct_out < BrakeAuxRpt_> BrakeAuxRpt__out;

        }

    }

}

#endif /* _H_B120394884D6EA43F500A7C72AD27CB7_BrakeAuxRpt__H_ */
