#ifndef _H_B120394884D6EA43F500A7C72AD27CB7_BrakeAuxRpt_DCPS_H_
#define _H_B120394884D6EA43F500A7C72AD27CB7_BrakeAuxRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BrakeAuxRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BrakeAuxRpt_TypeSupportInterface;

            typedef BrakeAuxRpt_TypeSupportInterface * BrakeAuxRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BrakeAuxRpt_TypeSupportInterface> BrakeAuxRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BrakeAuxRpt_TypeSupportInterface> BrakeAuxRpt_TypeSupportInterface_out;


            class BrakeAuxRpt_DataWriter;

            typedef BrakeAuxRpt_DataWriter * BrakeAuxRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BrakeAuxRpt_DataWriter> BrakeAuxRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < BrakeAuxRpt_DataWriter> BrakeAuxRpt_DataWriter_out;


            class BrakeAuxRpt_DataReader;

            typedef BrakeAuxRpt_DataReader * BrakeAuxRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BrakeAuxRpt_DataReader> BrakeAuxRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < BrakeAuxRpt_DataReader> BrakeAuxRpt_DataReader_out;


            class BrakeAuxRpt_DataReaderView;

            typedef BrakeAuxRpt_DataReaderView * BrakeAuxRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BrakeAuxRpt_DataReaderView> BrakeAuxRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BrakeAuxRpt_DataReaderView> BrakeAuxRpt_DataReaderView_out;

            struct BrakeAuxRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BrakeAuxRpt_, struct BrakeAuxRpt_Seq_uniq_> BrakeAuxRpt_Seq;
            typedef DDS_DCPSSequence_var < BrakeAuxRpt_Seq> BrakeAuxRpt_Seq_var;
            typedef DDS_DCPSSequence_out < BrakeAuxRpt_Seq> BrakeAuxRpt_Seq_out;

            class  BrakeAuxRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BrakeAuxRpt_TypeSupportInterface_ptr _ptr_type;
                typedef BrakeAuxRpt_TypeSupportInterface_var _var_type;

                static BrakeAuxRpt_TypeSupportInterface_ptr _duplicate (BrakeAuxRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeAuxRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BrakeAuxRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeAuxRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeAuxRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BrakeAuxRpt_TypeSupportInterface () {};
                ~BrakeAuxRpt_TypeSupportInterface () {};
            private:
                BrakeAuxRpt_TypeSupportInterface (const BrakeAuxRpt_TypeSupportInterface &);
                BrakeAuxRpt_TypeSupportInterface & operator = (const BrakeAuxRpt_TypeSupportInterface &);
            };

            class  BrakeAuxRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BrakeAuxRpt_DataWriter_ptr _ptr_type;
                typedef BrakeAuxRpt_DataWriter_var _var_type;

                static BrakeAuxRpt_DataWriter_ptr _duplicate (BrakeAuxRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeAuxRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BrakeAuxRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeAuxRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeAuxRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BrakeAuxRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BrakeAuxRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BrakeAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BrakeAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BrakeAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BrakeAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BrakeAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BrakeAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BrakeAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BrakeAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BrakeAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeAuxRpt_& instance_data) = 0;

            protected:
                BrakeAuxRpt_DataWriter () {};
                ~BrakeAuxRpt_DataWriter () {};
            private:
                BrakeAuxRpt_DataWriter (const BrakeAuxRpt_DataWriter &);
                BrakeAuxRpt_DataWriter & operator = (const BrakeAuxRpt_DataWriter &);
            };

            class  BrakeAuxRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BrakeAuxRpt_DataReader_ptr _ptr_type;
                typedef BrakeAuxRpt_DataReader_var _var_type;

                static BrakeAuxRpt_DataReader_ptr _duplicate (BrakeAuxRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeAuxRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BrakeAuxRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeAuxRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeAuxRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BrakeAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BrakeAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BrakeAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeAuxRpt_& instance) = 0;

            protected:
                BrakeAuxRpt_DataReader () {};
                ~BrakeAuxRpt_DataReader () {};
            private:
                BrakeAuxRpt_DataReader (const BrakeAuxRpt_DataReader &);
                BrakeAuxRpt_DataReader & operator = (const BrakeAuxRpt_DataReader &);
            };

            class  BrakeAuxRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BrakeAuxRpt_DataReaderView_ptr _ptr_type;
                typedef BrakeAuxRpt_DataReaderView_var _var_type;

                static BrakeAuxRpt_DataReaderView_ptr _duplicate (BrakeAuxRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeAuxRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BrakeAuxRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeAuxRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeAuxRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BrakeAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BrakeAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BrakeAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BrakeAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeAuxRpt_& instance) = 0;

            protected:
                BrakeAuxRpt_DataReaderView () {};
                ~BrakeAuxRpt_DataReaderView () {};
            private:
                BrakeAuxRpt_DataReaderView (const BrakeAuxRpt_DataReaderView &);
                BrakeAuxRpt_DataReaderView & operator = (const BrakeAuxRpt_DataReaderView &);
            };
        }

    }

}

#endif
