#ifndef _H_2C1EF16CD5241472B39B83AF603BB0BB_ComponentRpt__H_
#define _H_2C1EF16CD5241472B39B83AF603BB0BB_ComponentRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ComponentRpt_Constants
            {
                const ::DDS::Octet COMPONENT_TYPE_PACMOD_ = 0;

                const ::DDS::Octet COMPONENT_TYPE_PACMINI_ = 1;

                const ::DDS::Octet COMPONENT_TYPE_PACMICRO_ = 2;

                const ::DDS::Octet COMPONENT_FUNC_PACMOD_ = 0;

                const ::DDS::Octet COMPONENT_FUNC_STEERING_AND_STEERING_COLUMN_ = 1;

                const ::DDS::Octet COMPONENT_FUNC_ACCELERATOR_AND_BRAKING_ = 2;

                const ::DDS::Octet COMPONENT_FUNC_BRAKING_ = 3;

                const ::DDS::Octet COMPONENT_FUNC_SHIFTING_ = 4;

                const ::DDS::Octet COMPONENT_FUNC_STEERING_ = 5;

                const ::DDS::Octet COMPONENT_FUNC_E_SHIFTER_ = 6;

                const ::DDS::Octet COMPONENT_FUNC_WATCHDOG_ = 7;

            }

            struct  ComponentRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet component_type_;
                ::DDS::Octet component_func_;
                ::DDS::Octet counter_;
                ::DDS::Octet complement_;
                ::DDS::Boolean config_fault_;
            };

            typedef DDS_DCPSStruct_var<ComponentRpt_> ComponentRpt__var;
            typedef DDS_DCPSStruct_out < ComponentRpt_> ComponentRpt__out;

        }

    }

}

#endif /* _H_2C1EF16CD5241472B39B83AF603BB0BB_ComponentRpt__H_ */
