#ifndef _H_2C1EF16CD5241472B39B83AF603BB0BB_ComponentRpt_DCPS_H_
#define _H_2C1EF16CD5241472B39B83AF603BB0BB_ComponentRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ComponentRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ComponentRpt_TypeSupportInterface;

            typedef ComponentRpt_TypeSupportInterface * ComponentRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ComponentRpt_TypeSupportInterface> ComponentRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ComponentRpt_TypeSupportInterface> ComponentRpt_TypeSupportInterface_out;


            class ComponentRpt_DataWriter;

            typedef ComponentRpt_DataWriter * ComponentRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ComponentRpt_DataWriter> ComponentRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < ComponentRpt_DataWriter> ComponentRpt_DataWriter_out;


            class ComponentRpt_DataReader;

            typedef ComponentRpt_DataReader * ComponentRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ComponentRpt_DataReader> ComponentRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < ComponentRpt_DataReader> ComponentRpt_DataReader_out;


            class ComponentRpt_DataReaderView;

            typedef ComponentRpt_DataReaderView * ComponentRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ComponentRpt_DataReaderView> ComponentRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ComponentRpt_DataReaderView> ComponentRpt_DataReaderView_out;

            struct ComponentRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ComponentRpt_, struct ComponentRpt_Seq_uniq_> ComponentRpt_Seq;
            typedef DDS_DCPSSequence_var < ComponentRpt_Seq> ComponentRpt_Seq_var;
            typedef DDS_DCPSSequence_out < ComponentRpt_Seq> ComponentRpt_Seq_out;

            class  ComponentRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ComponentRpt_TypeSupportInterface_ptr _ptr_type;
                typedef ComponentRpt_TypeSupportInterface_var _var_type;

                static ComponentRpt_TypeSupportInterface_ptr _duplicate (ComponentRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComponentRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ComponentRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComponentRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ComponentRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ComponentRpt_TypeSupportInterface () {};
                ~ComponentRpt_TypeSupportInterface () {};
            private:
                ComponentRpt_TypeSupportInterface (const ComponentRpt_TypeSupportInterface &);
                ComponentRpt_TypeSupportInterface & operator = (const ComponentRpt_TypeSupportInterface &);
            };

            class  ComponentRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ComponentRpt_DataWriter_ptr _ptr_type;
                typedef ComponentRpt_DataWriter_var _var_type;

                static ComponentRpt_DataWriter_ptr _duplicate (ComponentRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComponentRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ComponentRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComponentRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ComponentRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ComponentRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ComponentRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ComponentRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ComponentRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ComponentRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ComponentRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ComponentRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ComponentRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ComponentRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ComponentRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ComponentRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComponentRpt_& instance_data) = 0;

            protected:
                ComponentRpt_DataWriter () {};
                ~ComponentRpt_DataWriter () {};
            private:
                ComponentRpt_DataWriter (const ComponentRpt_DataWriter &);
                ComponentRpt_DataWriter & operator = (const ComponentRpt_DataWriter &);
            };

            class  ComponentRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ComponentRpt_DataReader_ptr _ptr_type;
                typedef ComponentRpt_DataReader_var _var_type;

                static ComponentRpt_DataReader_ptr _duplicate (ComponentRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComponentRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ComponentRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComponentRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ComponentRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ComponentRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ComponentRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ComponentRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComponentRpt_& instance) = 0;

            protected:
                ComponentRpt_DataReader () {};
                ~ComponentRpt_DataReader () {};
            private:
                ComponentRpt_DataReader (const ComponentRpt_DataReader &);
                ComponentRpt_DataReader & operator = (const ComponentRpt_DataReader &);
            };

            class  ComponentRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ComponentRpt_DataReaderView_ptr _ptr_type;
                typedef ComponentRpt_DataReaderView_var _var_type;

                static ComponentRpt_DataReaderView_ptr _duplicate (ComponentRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComponentRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ComponentRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComponentRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ComponentRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ComponentRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ComponentRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ComponentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ComponentRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComponentRpt_& instance) = 0;

            protected:
                ComponentRpt_DataReaderView () {};
                ~ComponentRpt_DataReaderView () {};
            private:
                ComponentRpt_DataReaderView (const ComponentRpt_DataReaderView &);
                ComponentRpt_DataReaderView & operator = (const ComponentRpt_DataReaderView &);
            };
        }

    }

}

#endif
