#ifndef _H_ADA60F50B543F56B442B2AC2C2DC16E9_DoorRpt__H_
#define _H_ADA60F50B543F56B442B2AC2C2DC16E9_DoorRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  DoorRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean driver_door_open_;
                ::DDS::Boolean driver_door_open_is_valid_;
                ::DDS::Boolean passenger_door_open_;
                ::DDS::Boolean passenger_door_open_is_valid_;
                ::DDS::Boolean rear_driver_door_open_;
                ::DDS::Boolean rear_driver_door_open_is_valid_;
                ::DDS::Boolean rear_passenger_door_open_;
                ::DDS::Boolean rear_passenger_door_open_is_valid_;
                ::DDS::Boolean hood_open_;
                ::DDS::Boolean hood_open_is_valid_;
                ::DDS::Boolean trunk_open_;
                ::DDS::Boolean trunk_open_is_valid_;
                ::DDS::Boolean fuel_door_open_;
                ::DDS::Boolean fuel_door_open_is_valid_;
            };

            typedef DDS_DCPSStruct_var<DoorRpt_> DoorRpt__var;
            typedef DDS_DCPSStruct_out < DoorRpt_> DoorRpt__out;

        }

    }

}

#endif /* _H_ADA60F50B543F56B442B2AC2C2DC16E9_DoorRpt__H_ */
