#ifndef _H_9A0BB790C77E8D7528FF10245D31CB0B_EngineRpt__H_
#define _H_9A0BB790C77E8D7528FF10245D31CB0B_EngineRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  EngineRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double engine_speed_;
                ::DDS::Double engine_torque_;
                ::DDS::Short engine_coolant_temp_;
                ::DDS::Boolean engine_speed_avail_;
                ::DDS::Boolean engine_torque_avail_;
                ::DDS::Boolean engine_coolant_temp_avail_;
            };

            typedef DDS_DCPSStruct_var<EngineRpt_> EngineRpt__var;
            typedef DDS_DCPSStruct_out < EngineRpt_> EngineRpt__out;

        }

    }

}

#endif /* _H_9A0BB790C77E8D7528FF10245D31CB0B_EngineRpt__H_ */
