#ifndef _H_9A0BB790C77E8D7528FF10245D31CB0B_EngineRpt_DCPS_H_
#define _H_9A0BB790C77E8D7528FF10245D31CB0B_EngineRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EngineRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EngineRpt_TypeSupportInterface;

            typedef EngineRpt_TypeSupportInterface * EngineRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EngineRpt_TypeSupportInterface> EngineRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EngineRpt_TypeSupportInterface> EngineRpt_TypeSupportInterface_out;


            class EngineRpt_DataWriter;

            typedef EngineRpt_DataWriter * EngineRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EngineRpt_DataWriter> EngineRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < EngineRpt_DataWriter> EngineRpt_DataWriter_out;


            class EngineRpt_DataReader;

            typedef EngineRpt_DataReader * EngineRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EngineRpt_DataReader> EngineRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < EngineRpt_DataReader> EngineRpt_DataReader_out;


            class EngineRpt_DataReaderView;

            typedef EngineRpt_DataReaderView * EngineRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EngineRpt_DataReaderView> EngineRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EngineRpt_DataReaderView> EngineRpt_DataReaderView_out;

            struct EngineRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EngineRpt_, struct EngineRpt_Seq_uniq_> EngineRpt_Seq;
            typedef DDS_DCPSSequence_var < EngineRpt_Seq> EngineRpt_Seq_var;
            typedef DDS_DCPSSequence_out < EngineRpt_Seq> EngineRpt_Seq_out;

            class  EngineRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EngineRpt_TypeSupportInterface_ptr _ptr_type;
                typedef EngineRpt_TypeSupportInterface_var _var_type;

                static EngineRpt_TypeSupportInterface_ptr _duplicate (EngineRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EngineRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EngineRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EngineRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EngineRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EngineRpt_TypeSupportInterface () {};
                ~EngineRpt_TypeSupportInterface () {};
            private:
                EngineRpt_TypeSupportInterface (const EngineRpt_TypeSupportInterface &);
                EngineRpt_TypeSupportInterface & operator = (const EngineRpt_TypeSupportInterface &);
            };

            class  EngineRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EngineRpt_DataWriter_ptr _ptr_type;
                typedef EngineRpt_DataWriter_var _var_type;

                static EngineRpt_DataWriter_ptr _duplicate (EngineRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EngineRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EngineRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EngineRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EngineRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EngineRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EngineRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EngineRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EngineRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EngineRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EngineRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EngineRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EngineRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EngineRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EngineRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EngineRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EngineRpt_& instance_data) = 0;

            protected:
                EngineRpt_DataWriter () {};
                ~EngineRpt_DataWriter () {};
            private:
                EngineRpt_DataWriter (const EngineRpt_DataWriter &);
                EngineRpt_DataWriter & operator = (const EngineRpt_DataWriter &);
            };

            class  EngineRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EngineRpt_DataReader_ptr _ptr_type;
                typedef EngineRpt_DataReader_var _var_type;

                static EngineRpt_DataReader_ptr _duplicate (EngineRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EngineRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EngineRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EngineRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EngineRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EngineRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EngineRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EngineRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EngineRpt_& instance) = 0;

            protected:
                EngineRpt_DataReader () {};
                ~EngineRpt_DataReader () {};
            private:
                EngineRpt_DataReader (const EngineRpt_DataReader &);
                EngineRpt_DataReader & operator = (const EngineRpt_DataReader &);
            };

            class  EngineRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EngineRpt_DataReaderView_ptr _ptr_type;
                typedef EngineRpt_DataReaderView_var _var_type;

                static EngineRpt_DataReaderView_ptr _duplicate (EngineRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EngineRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EngineRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EngineRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EngineRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EngineRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EngineRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EngineRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EngineRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EngineRpt_& instance) = 0;

            protected:
                EngineRpt_DataReaderView () {};
                ~EngineRpt_DataReaderView () {};
            private:
                EngineRpt_DataReaderView (const EngineRpt_DataReaderView &);
                EngineRpt_DataReaderView & operator = (const EngineRpt_DataReaderView &);
            };
        }

    }

}

#endif
