#ifndef _H_97AF3A7032E782542D699D2310B8F2E1_GlobalRpt_DCPS_H_
#define _H_97AF3A7032E782542D699D2310B8F2E1_GlobalRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GlobalRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GlobalRpt_TypeSupportInterface;

            typedef GlobalRpt_TypeSupportInterface * GlobalRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GlobalRpt_TypeSupportInterface> GlobalRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GlobalRpt_TypeSupportInterface> GlobalRpt_TypeSupportInterface_out;


            class GlobalRpt_DataWriter;

            typedef GlobalRpt_DataWriter * GlobalRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GlobalRpt_DataWriter> GlobalRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < GlobalRpt_DataWriter> GlobalRpt_DataWriter_out;


            class GlobalRpt_DataReader;

            typedef GlobalRpt_DataReader * GlobalRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GlobalRpt_DataReader> GlobalRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < GlobalRpt_DataReader> GlobalRpt_DataReader_out;


            class GlobalRpt_DataReaderView;

            typedef GlobalRpt_DataReaderView * GlobalRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GlobalRpt_DataReaderView> GlobalRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GlobalRpt_DataReaderView> GlobalRpt_DataReaderView_out;

            struct GlobalRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GlobalRpt_, struct GlobalRpt_Seq_uniq_> GlobalRpt_Seq;
            typedef DDS_DCPSSequence_var < GlobalRpt_Seq> GlobalRpt_Seq_var;
            typedef DDS_DCPSSequence_out < GlobalRpt_Seq> GlobalRpt_Seq_out;

            class  GlobalRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GlobalRpt_TypeSupportInterface_ptr _ptr_type;
                typedef GlobalRpt_TypeSupportInterface_var _var_type;

                static GlobalRpt_TypeSupportInterface_ptr _duplicate (GlobalRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GlobalRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GlobalRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GlobalRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GlobalRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GlobalRpt_TypeSupportInterface () {};
                ~GlobalRpt_TypeSupportInterface () {};
            private:
                GlobalRpt_TypeSupportInterface (const GlobalRpt_TypeSupportInterface &);
                GlobalRpt_TypeSupportInterface & operator = (const GlobalRpt_TypeSupportInterface &);
            };

            class  GlobalRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GlobalRpt_DataWriter_ptr _ptr_type;
                typedef GlobalRpt_DataWriter_var _var_type;

                static GlobalRpt_DataWriter_ptr _duplicate (GlobalRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GlobalRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GlobalRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GlobalRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GlobalRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GlobalRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GlobalRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GlobalRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GlobalRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GlobalRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GlobalRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GlobalRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GlobalRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GlobalRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GlobalRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GlobalRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GlobalRpt_& instance_data) = 0;

            protected:
                GlobalRpt_DataWriter () {};
                ~GlobalRpt_DataWriter () {};
            private:
                GlobalRpt_DataWriter (const GlobalRpt_DataWriter &);
                GlobalRpt_DataWriter & operator = (const GlobalRpt_DataWriter &);
            };

            class  GlobalRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GlobalRpt_DataReader_ptr _ptr_type;
                typedef GlobalRpt_DataReader_var _var_type;

                static GlobalRpt_DataReader_ptr _duplicate (GlobalRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GlobalRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GlobalRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GlobalRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GlobalRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GlobalRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GlobalRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GlobalRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GlobalRpt_& instance) = 0;

            protected:
                GlobalRpt_DataReader () {};
                ~GlobalRpt_DataReader () {};
            private:
                GlobalRpt_DataReader (const GlobalRpt_DataReader &);
                GlobalRpt_DataReader & operator = (const GlobalRpt_DataReader &);
            };

            class  GlobalRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GlobalRpt_DataReaderView_ptr _ptr_type;
                typedef GlobalRpt_DataReaderView_var _var_type;

                static GlobalRpt_DataReaderView_ptr _duplicate (GlobalRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GlobalRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GlobalRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GlobalRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GlobalRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GlobalRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GlobalRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GlobalRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GlobalRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GlobalRpt_& instance) = 0;

            protected:
                GlobalRpt_DataReaderView () {};
                ~GlobalRpt_DataReaderView () {};
            private:
                GlobalRpt_DataReaderView (const GlobalRpt_DataReaderView &);
                GlobalRpt_DataReaderView & operator = (const GlobalRpt_DataReaderView &);
            };
        }

    }

}

#endif
