#ifndef _H_A66EC4C289CE2609971AC7F3BB338A2A_HeadlightAuxRpt__H_
#define _H_A66EC4C289CE2609971AC7F3BB338A2A_HeadlightAuxRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace HeadlightAuxRpt_Constants
            {
                const ::DDS::Octet HEADLIGHTS_OFF_ = 0;

                const ::DDS::Octet HEADLIGHTS_PARKING_ = 1;

                const ::DDS::Octet HEADLIGHTS_MANUAL_ = 2;

                const ::DDS::Octet HEADLIGHTS_AUTO_ = 3;

            }

            struct  HeadlightAuxRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean headlights_on_;
                ::DDS::Boolean headlights_on_is_valid_;
                ::DDS::Boolean headlights_on_bright_;
                ::DDS::Boolean headlights_on_bright_is_valid_;
                ::DDS::Boolean fog_lights_on_;
                ::DDS::Boolean fog_lights_on_is_valid_;
                ::DDS::Octet headlights_mode_;
                ::DDS::Boolean headlights_mode_is_valid_;
            };

            typedef DDS_DCPSStruct_var<HeadlightAuxRpt_> HeadlightAuxRpt__var;
            typedef DDS_DCPSStruct_out < HeadlightAuxRpt_> HeadlightAuxRpt__out;

        }

    }

}

#endif /* _H_A66EC4C289CE2609971AC7F3BB338A2A_HeadlightAuxRpt__H_ */
