#ifndef _H_A66EC4C289CE2609971AC7F3BB338A2A_HeadlightAuxRpt_DCPS_H_
#define _H_A66EC4C289CE2609971AC7F3BB338A2A_HeadlightAuxRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HeadlightAuxRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HeadlightAuxRpt_TypeSupportInterface;

            typedef HeadlightAuxRpt_TypeSupportInterface * HeadlightAuxRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HeadlightAuxRpt_TypeSupportInterface> HeadlightAuxRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HeadlightAuxRpt_TypeSupportInterface> HeadlightAuxRpt_TypeSupportInterface_out;


            class HeadlightAuxRpt_DataWriter;

            typedef HeadlightAuxRpt_DataWriter * HeadlightAuxRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HeadlightAuxRpt_DataWriter> HeadlightAuxRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < HeadlightAuxRpt_DataWriter> HeadlightAuxRpt_DataWriter_out;


            class HeadlightAuxRpt_DataReader;

            typedef HeadlightAuxRpt_DataReader * HeadlightAuxRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HeadlightAuxRpt_DataReader> HeadlightAuxRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < HeadlightAuxRpt_DataReader> HeadlightAuxRpt_DataReader_out;


            class HeadlightAuxRpt_DataReaderView;

            typedef HeadlightAuxRpt_DataReaderView * HeadlightAuxRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HeadlightAuxRpt_DataReaderView> HeadlightAuxRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HeadlightAuxRpt_DataReaderView> HeadlightAuxRpt_DataReaderView_out;

            struct HeadlightAuxRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HeadlightAuxRpt_, struct HeadlightAuxRpt_Seq_uniq_> HeadlightAuxRpt_Seq;
            typedef DDS_DCPSSequence_var < HeadlightAuxRpt_Seq> HeadlightAuxRpt_Seq_var;
            typedef DDS_DCPSSequence_out < HeadlightAuxRpt_Seq> HeadlightAuxRpt_Seq_out;

            class  HeadlightAuxRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HeadlightAuxRpt_TypeSupportInterface_ptr _ptr_type;
                typedef HeadlightAuxRpt_TypeSupportInterface_var _var_type;

                static HeadlightAuxRpt_TypeSupportInterface_ptr _duplicate (HeadlightAuxRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HeadlightAuxRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HeadlightAuxRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HeadlightAuxRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HeadlightAuxRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HeadlightAuxRpt_TypeSupportInterface () {};
                ~HeadlightAuxRpt_TypeSupportInterface () {};
            private:
                HeadlightAuxRpt_TypeSupportInterface (const HeadlightAuxRpt_TypeSupportInterface &);
                HeadlightAuxRpt_TypeSupportInterface & operator = (const HeadlightAuxRpt_TypeSupportInterface &);
            };

            class  HeadlightAuxRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HeadlightAuxRpt_DataWriter_ptr _ptr_type;
                typedef HeadlightAuxRpt_DataWriter_var _var_type;

                static HeadlightAuxRpt_DataWriter_ptr _duplicate (HeadlightAuxRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HeadlightAuxRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HeadlightAuxRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HeadlightAuxRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HeadlightAuxRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HeadlightAuxRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HeadlightAuxRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HeadlightAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HeadlightAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HeadlightAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HeadlightAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HeadlightAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HeadlightAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HeadlightAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HeadlightAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HeadlightAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HeadlightAuxRpt_& instance_data) = 0;

            protected:
                HeadlightAuxRpt_DataWriter () {};
                ~HeadlightAuxRpt_DataWriter () {};
            private:
                HeadlightAuxRpt_DataWriter (const HeadlightAuxRpt_DataWriter &);
                HeadlightAuxRpt_DataWriter & operator = (const HeadlightAuxRpt_DataWriter &);
            };

            class  HeadlightAuxRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HeadlightAuxRpt_DataReader_ptr _ptr_type;
                typedef HeadlightAuxRpt_DataReader_var _var_type;

                static HeadlightAuxRpt_DataReader_ptr _duplicate (HeadlightAuxRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HeadlightAuxRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HeadlightAuxRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HeadlightAuxRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HeadlightAuxRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HeadlightAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HeadlightAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HeadlightAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HeadlightAuxRpt_& instance) = 0;

            protected:
                HeadlightAuxRpt_DataReader () {};
                ~HeadlightAuxRpt_DataReader () {};
            private:
                HeadlightAuxRpt_DataReader (const HeadlightAuxRpt_DataReader &);
                HeadlightAuxRpt_DataReader & operator = (const HeadlightAuxRpt_DataReader &);
            };

            class  HeadlightAuxRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HeadlightAuxRpt_DataReaderView_ptr _ptr_type;
                typedef HeadlightAuxRpt_DataReaderView_var _var_type;

                static HeadlightAuxRpt_DataReaderView_ptr _duplicate (HeadlightAuxRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HeadlightAuxRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HeadlightAuxRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HeadlightAuxRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HeadlightAuxRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HeadlightAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HeadlightAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HeadlightAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HeadlightAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HeadlightAuxRpt_& instance) = 0;

            protected:
                HeadlightAuxRpt_DataReaderView () {};
                ~HeadlightAuxRpt_DataReaderView () {};
            private:
                HeadlightAuxRpt_DataReaderView (const HeadlightAuxRpt_DataReaderView &);
                HeadlightAuxRpt_DataReaderView & operator = (const HeadlightAuxRpt_DataReaderView &);
            };
        }

    }

}

#endif
