#ifndef _H_F1E6F3A447E03C61128C640BD892BA19_InteriorLightsRpt__H_
#define _H_F1E6F3A447E03C61128C640BD892BA19_InteriorLightsRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace InteriorLightsRpt_Constants
            {
                const ::DDS::Octet DIM_LEVEL_MIN_ = 0;

                const ::DDS::Octet DIM_LEVEL_1_ = 1;

                const ::DDS::Octet DIM_LEVEL_2_ = 2;

                const ::DDS::Octet DIM_LEVEL_3_ = 3;

                const ::DDS::Octet DIM_LEVEL_4_ = 4;

                const ::DDS::Octet DIM_LEVEL_5_ = 5;

                const ::DDS::Octet DIM_LEVEL_6_ = 6;

                const ::DDS::Octet DIM_LEVEL_7_ = 7;

                const ::DDS::Octet DIM_LEVEL_8_ = 8;

                const ::DDS::Octet DIM_LEVEL_9_ = 9;

                const ::DDS::Octet DIM_LEVEL_10_ = 10;

                const ::DDS::Octet DIM_LEVEL_11_ = 11;

                const ::DDS::Octet DIM_LEVEL_MAX_ = 12;

            }

            struct  InteriorLightsRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean front_dome_lights_on_;
                ::DDS::Boolean front_dome_lights_on_is_valid_;
                ::DDS::Boolean rear_dome_lights_on_;
                ::DDS::Boolean rear_dome_lights_on_is_valid_;
                ::DDS::Boolean mood_lights_on_;
                ::DDS::Boolean mood_lights_on_is_valid_;
                ::DDS::Octet dim_level_;
                ::DDS::Boolean dim_level_is_valid_;
            };

            typedef DDS_DCPSStruct_var<InteriorLightsRpt_> InteriorLightsRpt__var;
            typedef DDS_DCPSStruct_out < InteriorLightsRpt_> InteriorLightsRpt__out;

        }

    }

}

#endif /* _H_F1E6F3A447E03C61128C640BD892BA19_InteriorLightsRpt__H_ */
