#ifndef _H_060CCC119F68FDE74BE89A21B6754561_KeyValuePair_DCPS_H_
#define _H_060CCC119F68FDE74BE89A21B6754561_KeyValuePair_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "KeyValuePair_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class KeyValuePair_TypeSupportInterface;

            typedef KeyValuePair_TypeSupportInterface * KeyValuePair_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < KeyValuePair_TypeSupportInterface> KeyValuePair_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < KeyValuePair_TypeSupportInterface> KeyValuePair_TypeSupportInterface_out;


            class KeyValuePair_DataWriter;

            typedef KeyValuePair_DataWriter * KeyValuePair_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < KeyValuePair_DataWriter> KeyValuePair_DataWriter_var;
            typedef DDS_DCPSInterface_out < KeyValuePair_DataWriter> KeyValuePair_DataWriter_out;


            class KeyValuePair_DataReader;

            typedef KeyValuePair_DataReader * KeyValuePair_DataReader_ptr;
            typedef DDS_DCPSInterface_var < KeyValuePair_DataReader> KeyValuePair_DataReader_var;
            typedef DDS_DCPSInterface_out < KeyValuePair_DataReader> KeyValuePair_DataReader_out;


            class KeyValuePair_DataReaderView;

            typedef KeyValuePair_DataReaderView * KeyValuePair_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < KeyValuePair_DataReaderView> KeyValuePair_DataReaderView_var;
            typedef DDS_DCPSInterface_out < KeyValuePair_DataReaderView> KeyValuePair_DataReaderView_out;

            struct KeyValuePair_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < KeyValuePair_, struct KeyValuePair_Seq_uniq_> KeyValuePair_Seq;
            typedef DDS_DCPSSequence_var < KeyValuePair_Seq> KeyValuePair_Seq_var;
            typedef DDS_DCPSSequence_out < KeyValuePair_Seq> KeyValuePair_Seq_out;

            class  KeyValuePair_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef KeyValuePair_TypeSupportInterface_ptr _ptr_type;
                typedef KeyValuePair_TypeSupportInterface_var _var_type;

                static KeyValuePair_TypeSupportInterface_ptr _duplicate (KeyValuePair_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyValuePair_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static KeyValuePair_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyValuePair_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyValuePair_TypeSupportInterface_ptr _this () { return this; }


            protected:
                KeyValuePair_TypeSupportInterface () {};
                ~KeyValuePair_TypeSupportInterface () {};
            private:
                KeyValuePair_TypeSupportInterface (const KeyValuePair_TypeSupportInterface &);
                KeyValuePair_TypeSupportInterface & operator = (const KeyValuePair_TypeSupportInterface &);
            };

            class  KeyValuePair_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef KeyValuePair_DataWriter_ptr _ptr_type;
                typedef KeyValuePair_DataWriter_var _var_type;

                static KeyValuePair_DataWriter_ptr _duplicate (KeyValuePair_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyValuePair_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static KeyValuePair_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyValuePair_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyValuePair_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const KeyValuePair_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const KeyValuePair_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const KeyValuePair_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const KeyValuePair_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const KeyValuePair_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const KeyValuePair_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const KeyValuePair_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const KeyValuePair_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const KeyValuePair_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const KeyValuePair_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (KeyValuePair_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyValuePair_& instance_data) = 0;

            protected:
                KeyValuePair_DataWriter () {};
                ~KeyValuePair_DataWriter () {};
            private:
                KeyValuePair_DataWriter (const KeyValuePair_DataWriter &);
                KeyValuePair_DataWriter & operator = (const KeyValuePair_DataWriter &);
            };

            class  KeyValuePair_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef KeyValuePair_DataReader_ptr _ptr_type;
                typedef KeyValuePair_DataReader_var _var_type;

                static KeyValuePair_DataReader_ptr _duplicate (KeyValuePair_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyValuePair_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static KeyValuePair_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyValuePair_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyValuePair_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KeyValuePair_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KeyValuePair_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KeyValuePair_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyValuePair_& instance) = 0;

            protected:
                KeyValuePair_DataReader () {};
                ~KeyValuePair_DataReader () {};
            private:
                KeyValuePair_DataReader (const KeyValuePair_DataReader &);
                KeyValuePair_DataReader & operator = (const KeyValuePair_DataReader &);
            };

            class  KeyValuePair_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef KeyValuePair_DataReaderView_ptr _ptr_type;
                typedef KeyValuePair_DataReaderView_var _var_type;

                static KeyValuePair_DataReaderView_ptr _duplicate (KeyValuePair_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyValuePair_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static KeyValuePair_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyValuePair_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyValuePair_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KeyValuePair_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KeyValuePair_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KeyValuePair_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KeyValuePair_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyValuePair_& instance) = 0;

            protected:
                KeyValuePair_DataReaderView () {};
                ~KeyValuePair_DataReaderView () {};
            private:
                KeyValuePair_DataReaderView (const KeyValuePair_DataReaderView &);
                KeyValuePair_DataReaderView & operator = (const KeyValuePair_DataReaderView &);
            };
        }

    }

}

#endif
