#ifndef _H_2D485E3FE5217384C7A306125D03E0B2_LatLonHeadingRpt_DCPS_H_
#define _H_2D485E3FE5217384C7A306125D03E0B2_LatLonHeadingRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LatLonHeadingRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LatLonHeadingRpt_TypeSupportInterface;

            typedef LatLonHeadingRpt_TypeSupportInterface * LatLonHeadingRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LatLonHeadingRpt_TypeSupportInterface> LatLonHeadingRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LatLonHeadingRpt_TypeSupportInterface> LatLonHeadingRpt_TypeSupportInterface_out;


            class LatLonHeadingRpt_DataWriter;

            typedef LatLonHeadingRpt_DataWriter * LatLonHeadingRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LatLonHeadingRpt_DataWriter> LatLonHeadingRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < LatLonHeadingRpt_DataWriter> LatLonHeadingRpt_DataWriter_out;


            class LatLonHeadingRpt_DataReader;

            typedef LatLonHeadingRpt_DataReader * LatLonHeadingRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LatLonHeadingRpt_DataReader> LatLonHeadingRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < LatLonHeadingRpt_DataReader> LatLonHeadingRpt_DataReader_out;


            class LatLonHeadingRpt_DataReaderView;

            typedef LatLonHeadingRpt_DataReaderView * LatLonHeadingRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LatLonHeadingRpt_DataReaderView> LatLonHeadingRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LatLonHeadingRpt_DataReaderView> LatLonHeadingRpt_DataReaderView_out;

            struct LatLonHeadingRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LatLonHeadingRpt_, struct LatLonHeadingRpt_Seq_uniq_> LatLonHeadingRpt_Seq;
            typedef DDS_DCPSSequence_var < LatLonHeadingRpt_Seq> LatLonHeadingRpt_Seq_var;
            typedef DDS_DCPSSequence_out < LatLonHeadingRpt_Seq> LatLonHeadingRpt_Seq_out;

            class  LatLonHeadingRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LatLonHeadingRpt_TypeSupportInterface_ptr _ptr_type;
                typedef LatLonHeadingRpt_TypeSupportInterface_var _var_type;

                static LatLonHeadingRpt_TypeSupportInterface_ptr _duplicate (LatLonHeadingRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LatLonHeadingRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LatLonHeadingRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LatLonHeadingRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LatLonHeadingRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LatLonHeadingRpt_TypeSupportInterface () {};
                ~LatLonHeadingRpt_TypeSupportInterface () {};
            private:
                LatLonHeadingRpt_TypeSupportInterface (const LatLonHeadingRpt_TypeSupportInterface &);
                LatLonHeadingRpt_TypeSupportInterface & operator = (const LatLonHeadingRpt_TypeSupportInterface &);
            };

            class  LatLonHeadingRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LatLonHeadingRpt_DataWriter_ptr _ptr_type;
                typedef LatLonHeadingRpt_DataWriter_var _var_type;

                static LatLonHeadingRpt_DataWriter_ptr _duplicate (LatLonHeadingRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LatLonHeadingRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LatLonHeadingRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LatLonHeadingRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LatLonHeadingRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LatLonHeadingRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LatLonHeadingRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LatLonHeadingRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LatLonHeadingRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LatLonHeadingRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LatLonHeadingRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LatLonHeadingRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LatLonHeadingRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LatLonHeadingRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LatLonHeadingRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LatLonHeadingRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LatLonHeadingRpt_& instance_data) = 0;

            protected:
                LatLonHeadingRpt_DataWriter () {};
                ~LatLonHeadingRpt_DataWriter () {};
            private:
                LatLonHeadingRpt_DataWriter (const LatLonHeadingRpt_DataWriter &);
                LatLonHeadingRpt_DataWriter & operator = (const LatLonHeadingRpt_DataWriter &);
            };

            class  LatLonHeadingRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LatLonHeadingRpt_DataReader_ptr _ptr_type;
                typedef LatLonHeadingRpt_DataReader_var _var_type;

                static LatLonHeadingRpt_DataReader_ptr _duplicate (LatLonHeadingRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LatLonHeadingRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LatLonHeadingRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LatLonHeadingRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LatLonHeadingRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LatLonHeadingRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LatLonHeadingRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LatLonHeadingRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LatLonHeadingRpt_& instance) = 0;

            protected:
                LatLonHeadingRpt_DataReader () {};
                ~LatLonHeadingRpt_DataReader () {};
            private:
                LatLonHeadingRpt_DataReader (const LatLonHeadingRpt_DataReader &);
                LatLonHeadingRpt_DataReader & operator = (const LatLonHeadingRpt_DataReader &);
            };

            class  LatLonHeadingRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LatLonHeadingRpt_DataReaderView_ptr _ptr_type;
                typedef LatLonHeadingRpt_DataReaderView_var _var_type;

                static LatLonHeadingRpt_DataReaderView_ptr _duplicate (LatLonHeadingRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LatLonHeadingRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LatLonHeadingRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LatLonHeadingRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LatLonHeadingRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LatLonHeadingRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LatLonHeadingRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LatLonHeadingRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LatLonHeadingRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LatLonHeadingRpt_& instance) = 0;

            protected:
                LatLonHeadingRpt_DataReaderView () {};
                ~LatLonHeadingRpt_DataReaderView () {};
            private:
                LatLonHeadingRpt_DataReaderView (const LatLonHeadingRpt_DataReaderView &);
                LatLonHeadingRpt_DataReaderView & operator = (const LatLonHeadingRpt_DataReaderView &);
            };
        }

    }

}

#endif
