#ifndef _H_DB81DC3C731AD5629D0C0C5343DAF878_MotorRpt2_DCPS_H_
#define _H_DB81DC3C731AD5629D0C0C5343DAF878_MotorRpt2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MotorRpt2_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MotorRpt2_TypeSupportInterface;

            typedef MotorRpt2_TypeSupportInterface * MotorRpt2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MotorRpt2_TypeSupportInterface> MotorRpt2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MotorRpt2_TypeSupportInterface> MotorRpt2_TypeSupportInterface_out;


            class MotorRpt2_DataWriter;

            typedef MotorRpt2_DataWriter * MotorRpt2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MotorRpt2_DataWriter> MotorRpt2_DataWriter_var;
            typedef DDS_DCPSInterface_out < MotorRpt2_DataWriter> MotorRpt2_DataWriter_out;


            class MotorRpt2_DataReader;

            typedef MotorRpt2_DataReader * MotorRpt2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MotorRpt2_DataReader> MotorRpt2_DataReader_var;
            typedef DDS_DCPSInterface_out < MotorRpt2_DataReader> MotorRpt2_DataReader_out;


            class MotorRpt2_DataReaderView;

            typedef MotorRpt2_DataReaderView * MotorRpt2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MotorRpt2_DataReaderView> MotorRpt2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MotorRpt2_DataReaderView> MotorRpt2_DataReaderView_out;

            struct MotorRpt2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MotorRpt2_, struct MotorRpt2_Seq_uniq_> MotorRpt2_Seq;
            typedef DDS_DCPSSequence_var < MotorRpt2_Seq> MotorRpt2_Seq_var;
            typedef DDS_DCPSSequence_out < MotorRpt2_Seq> MotorRpt2_Seq_out;

            class  MotorRpt2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MotorRpt2_TypeSupportInterface_ptr _ptr_type;
                typedef MotorRpt2_TypeSupportInterface_var _var_type;

                static MotorRpt2_TypeSupportInterface_ptr _duplicate (MotorRpt2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorRpt2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MotorRpt2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorRpt2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorRpt2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MotorRpt2_TypeSupportInterface () {};
                ~MotorRpt2_TypeSupportInterface () {};
            private:
                MotorRpt2_TypeSupportInterface (const MotorRpt2_TypeSupportInterface &);
                MotorRpt2_TypeSupportInterface & operator = (const MotorRpt2_TypeSupportInterface &);
            };

            class  MotorRpt2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MotorRpt2_DataWriter_ptr _ptr_type;
                typedef MotorRpt2_DataWriter_var _var_type;

                static MotorRpt2_DataWriter_ptr _duplicate (MotorRpt2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorRpt2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MotorRpt2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorRpt2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorRpt2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MotorRpt2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MotorRpt2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MotorRpt2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MotorRpt2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MotorRpt2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MotorRpt2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MotorRpt2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MotorRpt2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MotorRpt2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MotorRpt2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MotorRpt2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorRpt2_& instance_data) = 0;

            protected:
                MotorRpt2_DataWriter () {};
                ~MotorRpt2_DataWriter () {};
            private:
                MotorRpt2_DataWriter (const MotorRpt2_DataWriter &);
                MotorRpt2_DataWriter & operator = (const MotorRpt2_DataWriter &);
            };

            class  MotorRpt2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MotorRpt2_DataReader_ptr _ptr_type;
                typedef MotorRpt2_DataReader_var _var_type;

                static MotorRpt2_DataReader_ptr _duplicate (MotorRpt2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorRpt2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MotorRpt2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorRpt2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorRpt2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MotorRpt2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MotorRpt2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MotorRpt2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorRpt2_& instance) = 0;

            protected:
                MotorRpt2_DataReader () {};
                ~MotorRpt2_DataReader () {};
            private:
                MotorRpt2_DataReader (const MotorRpt2_DataReader &);
                MotorRpt2_DataReader & operator = (const MotorRpt2_DataReader &);
            };

            class  MotorRpt2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MotorRpt2_DataReaderView_ptr _ptr_type;
                typedef MotorRpt2_DataReaderView_var _var_type;

                static MotorRpt2_DataReaderView_ptr _duplicate (MotorRpt2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorRpt2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MotorRpt2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorRpt2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorRpt2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MotorRpt2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MotorRpt2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MotorRpt2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MotorRpt2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorRpt2_& instance) = 0;

            protected:
                MotorRpt2_DataReaderView () {};
                ~MotorRpt2_DataReaderView () {};
            private:
                MotorRpt2_DataReaderView (const MotorRpt2_DataReaderView &);
                MotorRpt2_DataReaderView & operator = (const MotorRpt2_DataReaderView &);
            };
        }

    }

}

#endif
