#ifndef _H_FBCB3149BC92226F0F74DD7C006D59D2_MotorRpt3_DCPS_H_
#define _H_FBCB3149BC92226F0F74DD7C006D59D2_MotorRpt3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MotorRpt3_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MotorRpt3_TypeSupportInterface;

            typedef MotorRpt3_TypeSupportInterface * MotorRpt3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MotorRpt3_TypeSupportInterface> MotorRpt3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MotorRpt3_TypeSupportInterface> MotorRpt3_TypeSupportInterface_out;


            class MotorRpt3_DataWriter;

            typedef MotorRpt3_DataWriter * MotorRpt3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MotorRpt3_DataWriter> MotorRpt3_DataWriter_var;
            typedef DDS_DCPSInterface_out < MotorRpt3_DataWriter> MotorRpt3_DataWriter_out;


            class MotorRpt3_DataReader;

            typedef MotorRpt3_DataReader * MotorRpt3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MotorRpt3_DataReader> MotorRpt3_DataReader_var;
            typedef DDS_DCPSInterface_out < MotorRpt3_DataReader> MotorRpt3_DataReader_out;


            class MotorRpt3_DataReaderView;

            typedef MotorRpt3_DataReaderView * MotorRpt3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MotorRpt3_DataReaderView> MotorRpt3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MotorRpt3_DataReaderView> MotorRpt3_DataReaderView_out;

            struct MotorRpt3_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MotorRpt3_, struct MotorRpt3_Seq_uniq_> MotorRpt3_Seq;
            typedef DDS_DCPSSequence_var < MotorRpt3_Seq> MotorRpt3_Seq_var;
            typedef DDS_DCPSSequence_out < MotorRpt3_Seq> MotorRpt3_Seq_out;

            class  MotorRpt3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MotorRpt3_TypeSupportInterface_ptr _ptr_type;
                typedef MotorRpt3_TypeSupportInterface_var _var_type;

                static MotorRpt3_TypeSupportInterface_ptr _duplicate (MotorRpt3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorRpt3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MotorRpt3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorRpt3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorRpt3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MotorRpt3_TypeSupportInterface () {};
                ~MotorRpt3_TypeSupportInterface () {};
            private:
                MotorRpt3_TypeSupportInterface (const MotorRpt3_TypeSupportInterface &);
                MotorRpt3_TypeSupportInterface & operator = (const MotorRpt3_TypeSupportInterface &);
            };

            class  MotorRpt3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MotorRpt3_DataWriter_ptr _ptr_type;
                typedef MotorRpt3_DataWriter_var _var_type;

                static MotorRpt3_DataWriter_ptr _duplicate (MotorRpt3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorRpt3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MotorRpt3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorRpt3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorRpt3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MotorRpt3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MotorRpt3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MotorRpt3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MotorRpt3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MotorRpt3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MotorRpt3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MotorRpt3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MotorRpt3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MotorRpt3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MotorRpt3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MotorRpt3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorRpt3_& instance_data) = 0;

            protected:
                MotorRpt3_DataWriter () {};
                ~MotorRpt3_DataWriter () {};
            private:
                MotorRpt3_DataWriter (const MotorRpt3_DataWriter &);
                MotorRpt3_DataWriter & operator = (const MotorRpt3_DataWriter &);
            };

            class  MotorRpt3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MotorRpt3_DataReader_ptr _ptr_type;
                typedef MotorRpt3_DataReader_var _var_type;

                static MotorRpt3_DataReader_ptr _duplicate (MotorRpt3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorRpt3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MotorRpt3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorRpt3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorRpt3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MotorRpt3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MotorRpt3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MotorRpt3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorRpt3_& instance) = 0;

            protected:
                MotorRpt3_DataReader () {};
                ~MotorRpt3_DataReader () {};
            private:
                MotorRpt3_DataReader (const MotorRpt3_DataReader &);
                MotorRpt3_DataReader & operator = (const MotorRpt3_DataReader &);
            };

            class  MotorRpt3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MotorRpt3_DataReaderView_ptr _ptr_type;
                typedef MotorRpt3_DataReaderView_var _var_type;

                static MotorRpt3_DataReaderView_ptr _duplicate (MotorRpt3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorRpt3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MotorRpt3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorRpt3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorRpt3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MotorRpt3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MotorRpt3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MotorRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MotorRpt3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorRpt3_& instance) = 0;

            protected:
                MotorRpt3_DataReaderView () {};
                ~MotorRpt3_DataReaderView () {};
            private:
                MotorRpt3_DataReaderView (const MotorRpt3_DataReaderView &);
                MotorRpt3_DataReaderView & operator = (const MotorRpt3_DataReaderView &);
            };
        }

    }

}

#endif
