#ifndef _H_EC89DB43A3FCC84CEE3E960F6F7983A7_OccupancyRpt__H_
#define _H_EC89DB43A3FCC84CEE3E960F6F7983A7_OccupancyRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  OccupancyRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean driver_seat_occupied_;
                ::DDS::Boolean driver_seat_occupied_is_valid_;
                ::DDS::Boolean passenger_seat_occupied_;
                ::DDS::Boolean passenger_seat_occupied_is_valid_;
                ::DDS::Boolean rear_seat_occupied_;
                ::DDS::Boolean rear_seat_occupied_is_valid_;
                ::DDS::Boolean driver_seatbelt_buckled_;
                ::DDS::Boolean driver_seatbelt_buckled_is_valid_;
                ::DDS::Boolean passenger_seatbelt_buckled_;
                ::DDS::Boolean passenger_seatbelt_buckled_is_valid_;
                ::DDS::Boolean rear_seatbelt_buckled_;
                ::DDS::Boolean rear_seatbelt_buckled_is_valid_;
            };

            typedef DDS_DCPSStruct_var<OccupancyRpt_> OccupancyRpt__var;
            typedef DDS_DCPSStruct_out < OccupancyRpt_> OccupancyRpt__out;

        }

    }

}

#endif /* _H_EC89DB43A3FCC84CEE3E960F6F7983A7_OccupancyRpt__H_ */
