#ifndef _H_EC89DB43A3FCC84CEE3E960F6F7983A7_OccupancyRpt_DCPS_H_
#define _H_EC89DB43A3FCC84CEE3E960F6F7983A7_OccupancyRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "OccupancyRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class OccupancyRpt_TypeSupportInterface;

            typedef OccupancyRpt_TypeSupportInterface * OccupancyRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OccupancyRpt_TypeSupportInterface> OccupancyRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OccupancyRpt_TypeSupportInterface> OccupancyRpt_TypeSupportInterface_out;


            class OccupancyRpt_DataWriter;

            typedef OccupancyRpt_DataWriter * OccupancyRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OccupancyRpt_DataWriter> OccupancyRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < OccupancyRpt_DataWriter> OccupancyRpt_DataWriter_out;


            class OccupancyRpt_DataReader;

            typedef OccupancyRpt_DataReader * OccupancyRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OccupancyRpt_DataReader> OccupancyRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < OccupancyRpt_DataReader> OccupancyRpt_DataReader_out;


            class OccupancyRpt_DataReaderView;

            typedef OccupancyRpt_DataReaderView * OccupancyRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OccupancyRpt_DataReaderView> OccupancyRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OccupancyRpt_DataReaderView> OccupancyRpt_DataReaderView_out;

            struct OccupancyRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < OccupancyRpt_, struct OccupancyRpt_Seq_uniq_> OccupancyRpt_Seq;
            typedef DDS_DCPSSequence_var < OccupancyRpt_Seq> OccupancyRpt_Seq_var;
            typedef DDS_DCPSSequence_out < OccupancyRpt_Seq> OccupancyRpt_Seq_out;

            class  OccupancyRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OccupancyRpt_TypeSupportInterface_ptr _ptr_type;
                typedef OccupancyRpt_TypeSupportInterface_var _var_type;

                static OccupancyRpt_TypeSupportInterface_ptr _duplicate (OccupancyRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OccupancyRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OccupancyRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OccupancyRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OccupancyRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OccupancyRpt_TypeSupportInterface () {};
                ~OccupancyRpt_TypeSupportInterface () {};
            private:
                OccupancyRpt_TypeSupportInterface (const OccupancyRpt_TypeSupportInterface &);
                OccupancyRpt_TypeSupportInterface & operator = (const OccupancyRpt_TypeSupportInterface &);
            };

            class  OccupancyRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OccupancyRpt_DataWriter_ptr _ptr_type;
                typedef OccupancyRpt_DataWriter_var _var_type;

                static OccupancyRpt_DataWriter_ptr _duplicate (OccupancyRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OccupancyRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OccupancyRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OccupancyRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OccupancyRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OccupancyRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OccupancyRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OccupancyRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OccupancyRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OccupancyRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OccupancyRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OccupancyRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OccupancyRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OccupancyRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OccupancyRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OccupancyRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OccupancyRpt_& instance_data) = 0;

            protected:
                OccupancyRpt_DataWriter () {};
                ~OccupancyRpt_DataWriter () {};
            private:
                OccupancyRpt_DataWriter (const OccupancyRpt_DataWriter &);
                OccupancyRpt_DataWriter & operator = (const OccupancyRpt_DataWriter &);
            };

            class  OccupancyRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OccupancyRpt_DataReader_ptr _ptr_type;
                typedef OccupancyRpt_DataReader_var _var_type;

                static OccupancyRpt_DataReader_ptr _duplicate (OccupancyRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OccupancyRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OccupancyRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OccupancyRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OccupancyRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OccupancyRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OccupancyRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OccupancyRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OccupancyRpt_& instance) = 0;

            protected:
                OccupancyRpt_DataReader () {};
                ~OccupancyRpt_DataReader () {};
            private:
                OccupancyRpt_DataReader (const OccupancyRpt_DataReader &);
                OccupancyRpt_DataReader & operator = (const OccupancyRpt_DataReader &);
            };

            class  OccupancyRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OccupancyRpt_DataReaderView_ptr _ptr_type;
                typedef OccupancyRpt_DataReaderView_var _var_type;

                static OccupancyRpt_DataReaderView_ptr _duplicate (OccupancyRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OccupancyRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OccupancyRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OccupancyRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OccupancyRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OccupancyRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OccupancyRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OccupancyRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OccupancyRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OccupancyRpt_& instance) = 0;

            protected:
                OccupancyRpt_DataReaderView () {};
                ~OccupancyRpt_DataReaderView () {};
            private:
                OccupancyRpt_DataReaderView (const OccupancyRpt_DataReaderView &);
                OccupancyRpt_DataReaderView & operator = (const OccupancyRpt_DataReaderView &);
            };
        }

    }

}

#endif
