#ifndef _H_6259C998B9C2EFDB4D9E0A09E04C9A33_PacmodCmd__H_
#define _H_6259C998B9C2EFDB4D9E0A09E04C9A33_PacmodCmd__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace PacmodCmd_Constants
            {
                const ::DDS::UShort TURN_RIGHT_ = 0U;

                const ::DDS::UShort TURN_NONE_ = 1U;

                const ::DDS::UShort TURN_LEFT_ = 2U;

                const ::DDS::UShort TURN_HAZARDS_ = 3U;

                const ::DDS::UShort SHIFT_PARK_ = 0U;

                const ::DDS::UShort SHIFT_REVERSE_ = 1U;

                const ::DDS::UShort SHIFT_NEUTRAL_ = 2U;

                const ::DDS::UShort SHIFT_FORWARD_ = 3U;

                const ::DDS::UShort SHIFT_HIGH_ = 3U;

                const ::DDS::UShort SHIFT_LOW_ = 4U;

            }

            struct  PacmodCmd_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double f64_cmd_;
                ::DDS::UShort ui16_cmd_;
                ::DDS::Boolean enable_;
                ::DDS::Boolean clear_;
                ::DDS::Boolean ignore_;
            };

            typedef DDS_DCPSStruct_var<PacmodCmd_> PacmodCmd__var;
            typedef DDS_DCPSStruct_out < PacmodCmd_> PacmodCmd__out;

        }

    }

}

#endif /* _H_6259C998B9C2EFDB4D9E0A09E04C9A33_PacmodCmd__H_ */
