#ifndef _H_6259C998B9C2EFDB4D9E0A09E04C9A33_PacmodCmd_DCPS_H_
#define _H_6259C998B9C2EFDB4D9E0A09E04C9A33_PacmodCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PacmodCmd_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PacmodCmd_TypeSupportInterface;

            typedef PacmodCmd_TypeSupportInterface * PacmodCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PacmodCmd_TypeSupportInterface> PacmodCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PacmodCmd_TypeSupportInterface> PacmodCmd_TypeSupportInterface_out;


            class PacmodCmd_DataWriter;

            typedef PacmodCmd_DataWriter * PacmodCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PacmodCmd_DataWriter> PacmodCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < PacmodCmd_DataWriter> PacmodCmd_DataWriter_out;


            class PacmodCmd_DataReader;

            typedef PacmodCmd_DataReader * PacmodCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PacmodCmd_DataReader> PacmodCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < PacmodCmd_DataReader> PacmodCmd_DataReader_out;


            class PacmodCmd_DataReaderView;

            typedef PacmodCmd_DataReaderView * PacmodCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PacmodCmd_DataReaderView> PacmodCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PacmodCmd_DataReaderView> PacmodCmd_DataReaderView_out;

            struct PacmodCmd_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PacmodCmd_, struct PacmodCmd_Seq_uniq_> PacmodCmd_Seq;
            typedef DDS_DCPSSequence_var < PacmodCmd_Seq> PacmodCmd_Seq_var;
            typedef DDS_DCPSSequence_out < PacmodCmd_Seq> PacmodCmd_Seq_out;

            class  PacmodCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PacmodCmd_TypeSupportInterface_ptr _ptr_type;
                typedef PacmodCmd_TypeSupportInterface_var _var_type;

                static PacmodCmd_TypeSupportInterface_ptr _duplicate (PacmodCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PacmodCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PacmodCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PacmodCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PacmodCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PacmodCmd_TypeSupportInterface () {};
                ~PacmodCmd_TypeSupportInterface () {};
            private:
                PacmodCmd_TypeSupportInterface (const PacmodCmd_TypeSupportInterface &);
                PacmodCmd_TypeSupportInterface & operator = (const PacmodCmd_TypeSupportInterface &);
            };

            class  PacmodCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PacmodCmd_DataWriter_ptr _ptr_type;
                typedef PacmodCmd_DataWriter_var _var_type;

                static PacmodCmd_DataWriter_ptr _duplicate (PacmodCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PacmodCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PacmodCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PacmodCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PacmodCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PacmodCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PacmodCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PacmodCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PacmodCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PacmodCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PacmodCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PacmodCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PacmodCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PacmodCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PacmodCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PacmodCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PacmodCmd_& instance_data) = 0;

            protected:
                PacmodCmd_DataWriter () {};
                ~PacmodCmd_DataWriter () {};
            private:
                PacmodCmd_DataWriter (const PacmodCmd_DataWriter &);
                PacmodCmd_DataWriter & operator = (const PacmodCmd_DataWriter &);
            };

            class  PacmodCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PacmodCmd_DataReader_ptr _ptr_type;
                typedef PacmodCmd_DataReader_var _var_type;

                static PacmodCmd_DataReader_ptr _duplicate (PacmodCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PacmodCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PacmodCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PacmodCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PacmodCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PacmodCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PacmodCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PacmodCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PacmodCmd_& instance) = 0;

            protected:
                PacmodCmd_DataReader () {};
                ~PacmodCmd_DataReader () {};
            private:
                PacmodCmd_DataReader (const PacmodCmd_DataReader &);
                PacmodCmd_DataReader & operator = (const PacmodCmd_DataReader &);
            };

            class  PacmodCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PacmodCmd_DataReaderView_ptr _ptr_type;
                typedef PacmodCmd_DataReaderView_var _var_type;

                static PacmodCmd_DataReaderView_ptr _duplicate (PacmodCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PacmodCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PacmodCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PacmodCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PacmodCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PacmodCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PacmodCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PacmodCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PacmodCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PacmodCmd_& instance) = 0;

            protected:
                PacmodCmd_DataReaderView () {};
                ~PacmodCmd_DataReaderView () {};
            private:
                PacmodCmd_DataReaderView (const PacmodCmd_DataReaderView &);
                PacmodCmd_DataReaderView & operator = (const PacmodCmd_DataReaderView &);
            };
        }

    }

}

#endif
