#ifndef _H_E6334973B278BFDD8E07534DC3C204E4_PositionWithSpeed_DCPS_H_
#define _H_E6334973B278BFDD8E07534DC3C204E4_PositionWithSpeed_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionWithSpeed_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionWithSpeed_TypeSupportInterface;

            typedef PositionWithSpeed_TypeSupportInterface * PositionWithSpeed_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionWithSpeed_TypeSupportInterface> PositionWithSpeed_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionWithSpeed_TypeSupportInterface> PositionWithSpeed_TypeSupportInterface_out;


            class PositionWithSpeed_DataWriter;

            typedef PositionWithSpeed_DataWriter * PositionWithSpeed_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionWithSpeed_DataWriter> PositionWithSpeed_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionWithSpeed_DataWriter> PositionWithSpeed_DataWriter_out;


            class PositionWithSpeed_DataReader;

            typedef PositionWithSpeed_DataReader * PositionWithSpeed_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionWithSpeed_DataReader> PositionWithSpeed_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionWithSpeed_DataReader> PositionWithSpeed_DataReader_out;


            class PositionWithSpeed_DataReaderView;

            typedef PositionWithSpeed_DataReaderView * PositionWithSpeed_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionWithSpeed_DataReaderView> PositionWithSpeed_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionWithSpeed_DataReaderView> PositionWithSpeed_DataReaderView_out;

            struct PositionWithSpeed_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PositionWithSpeed_, struct PositionWithSpeed_Seq_uniq_> PositionWithSpeed_Seq;
            typedef DDS_DCPSSequence_var < PositionWithSpeed_Seq> PositionWithSpeed_Seq_var;
            typedef DDS_DCPSSequence_out < PositionWithSpeed_Seq> PositionWithSpeed_Seq_out;

            class  PositionWithSpeed_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionWithSpeed_TypeSupportInterface_ptr _ptr_type;
                typedef PositionWithSpeed_TypeSupportInterface_var _var_type;

                static PositionWithSpeed_TypeSupportInterface_ptr _duplicate (PositionWithSpeed_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionWithSpeed_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionWithSpeed_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionWithSpeed_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionWithSpeed_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionWithSpeed_TypeSupportInterface () {};
                ~PositionWithSpeed_TypeSupportInterface () {};
            private:
                PositionWithSpeed_TypeSupportInterface (const PositionWithSpeed_TypeSupportInterface &);
                PositionWithSpeed_TypeSupportInterface & operator = (const PositionWithSpeed_TypeSupportInterface &);
            };

            class  PositionWithSpeed_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionWithSpeed_DataWriter_ptr _ptr_type;
                typedef PositionWithSpeed_DataWriter_var _var_type;

                static PositionWithSpeed_DataWriter_ptr _duplicate (PositionWithSpeed_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionWithSpeed_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionWithSpeed_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionWithSpeed_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionWithSpeed_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionWithSpeed_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionWithSpeed_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionWithSpeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionWithSpeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionWithSpeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionWithSpeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionWithSpeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionWithSpeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionWithSpeed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionWithSpeed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionWithSpeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionWithSpeed_& instance_data) = 0;

            protected:
                PositionWithSpeed_DataWriter () {};
                ~PositionWithSpeed_DataWriter () {};
            private:
                PositionWithSpeed_DataWriter (const PositionWithSpeed_DataWriter &);
                PositionWithSpeed_DataWriter & operator = (const PositionWithSpeed_DataWriter &);
            };

            class  PositionWithSpeed_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionWithSpeed_DataReader_ptr _ptr_type;
                typedef PositionWithSpeed_DataReader_var _var_type;

                static PositionWithSpeed_DataReader_ptr _duplicate (PositionWithSpeed_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionWithSpeed_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionWithSpeed_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionWithSpeed_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionWithSpeed_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionWithSpeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionWithSpeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionWithSpeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionWithSpeed_& instance) = 0;

            protected:
                PositionWithSpeed_DataReader () {};
                ~PositionWithSpeed_DataReader () {};
            private:
                PositionWithSpeed_DataReader (const PositionWithSpeed_DataReader &);
                PositionWithSpeed_DataReader & operator = (const PositionWithSpeed_DataReader &);
            };

            class  PositionWithSpeed_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionWithSpeed_DataReaderView_ptr _ptr_type;
                typedef PositionWithSpeed_DataReaderView_var _var_type;

                static PositionWithSpeed_DataReaderView_ptr _duplicate (PositionWithSpeed_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionWithSpeed_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionWithSpeed_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionWithSpeed_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionWithSpeed_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionWithSpeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionWithSpeed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionWithSpeed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionWithSpeed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionWithSpeed_& instance) = 0;

            protected:
                PositionWithSpeed_DataReaderView () {};
                ~PositionWithSpeed_DataReaderView () {};
            private:
                PositionWithSpeed_DataReaderView (const PositionWithSpeed_DataReaderView &);
                PositionWithSpeed_DataReaderView & operator = (const PositionWithSpeed_DataReaderView &);
            };
        }

    }

}

#endif
