#ifndef _H_261A0F8A277283F6B44A19721ACCBA71_RearLightsRpt_DCPS_H_
#define _H_261A0F8A277283F6B44A19721ACCBA71_RearLightsRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RearLightsRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RearLightsRpt_TypeSupportInterface;

            typedef RearLightsRpt_TypeSupportInterface * RearLightsRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RearLightsRpt_TypeSupportInterface> RearLightsRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RearLightsRpt_TypeSupportInterface> RearLightsRpt_TypeSupportInterface_out;


            class RearLightsRpt_DataWriter;

            typedef RearLightsRpt_DataWriter * RearLightsRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RearLightsRpt_DataWriter> RearLightsRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < RearLightsRpt_DataWriter> RearLightsRpt_DataWriter_out;


            class RearLightsRpt_DataReader;

            typedef RearLightsRpt_DataReader * RearLightsRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RearLightsRpt_DataReader> RearLightsRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < RearLightsRpt_DataReader> RearLightsRpt_DataReader_out;


            class RearLightsRpt_DataReaderView;

            typedef RearLightsRpt_DataReaderView * RearLightsRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RearLightsRpt_DataReaderView> RearLightsRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RearLightsRpt_DataReaderView> RearLightsRpt_DataReaderView_out;

            struct RearLightsRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RearLightsRpt_, struct RearLightsRpt_Seq_uniq_> RearLightsRpt_Seq;
            typedef DDS_DCPSSequence_var < RearLightsRpt_Seq> RearLightsRpt_Seq_var;
            typedef DDS_DCPSSequence_out < RearLightsRpt_Seq> RearLightsRpt_Seq_out;

            class  RearLightsRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RearLightsRpt_TypeSupportInterface_ptr _ptr_type;
                typedef RearLightsRpt_TypeSupportInterface_var _var_type;

                static RearLightsRpt_TypeSupportInterface_ptr _duplicate (RearLightsRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RearLightsRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RearLightsRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RearLightsRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RearLightsRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RearLightsRpt_TypeSupportInterface () {};
                ~RearLightsRpt_TypeSupportInterface () {};
            private:
                RearLightsRpt_TypeSupportInterface (const RearLightsRpt_TypeSupportInterface &);
                RearLightsRpt_TypeSupportInterface & operator = (const RearLightsRpt_TypeSupportInterface &);
            };

            class  RearLightsRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RearLightsRpt_DataWriter_ptr _ptr_type;
                typedef RearLightsRpt_DataWriter_var _var_type;

                static RearLightsRpt_DataWriter_ptr _duplicate (RearLightsRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RearLightsRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RearLightsRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RearLightsRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RearLightsRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RearLightsRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RearLightsRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RearLightsRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RearLightsRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RearLightsRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RearLightsRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RearLightsRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RearLightsRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RearLightsRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RearLightsRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RearLightsRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RearLightsRpt_& instance_data) = 0;

            protected:
                RearLightsRpt_DataWriter () {};
                ~RearLightsRpt_DataWriter () {};
            private:
                RearLightsRpt_DataWriter (const RearLightsRpt_DataWriter &);
                RearLightsRpt_DataWriter & operator = (const RearLightsRpt_DataWriter &);
            };

            class  RearLightsRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RearLightsRpt_DataReader_ptr _ptr_type;
                typedef RearLightsRpt_DataReader_var _var_type;

                static RearLightsRpt_DataReader_ptr _duplicate (RearLightsRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RearLightsRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RearLightsRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RearLightsRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RearLightsRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RearLightsRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RearLightsRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RearLightsRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RearLightsRpt_& instance) = 0;

            protected:
                RearLightsRpt_DataReader () {};
                ~RearLightsRpt_DataReader () {};
            private:
                RearLightsRpt_DataReader (const RearLightsRpt_DataReader &);
                RearLightsRpt_DataReader & operator = (const RearLightsRpt_DataReader &);
            };

            class  RearLightsRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RearLightsRpt_DataReaderView_ptr _ptr_type;
                typedef RearLightsRpt_DataReaderView_var _var_type;

                static RearLightsRpt_DataReaderView_ptr _duplicate (RearLightsRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RearLightsRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RearLightsRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RearLightsRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RearLightsRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RearLightsRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RearLightsRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RearLightsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RearLightsRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RearLightsRpt_& instance) = 0;

            protected:
                RearLightsRpt_DataReaderView () {};
                ~RearLightsRpt_DataReaderView () {};
            private:
                RearLightsRpt_DataReaderView (const RearLightsRpt_DataReaderView &);
                RearLightsRpt_DataReaderView & operator = (const RearLightsRpt_DataReaderView &);
            };
        }

    }

}

#endif
