#ifndef _H_D8CC0A64881C99F414694EC75A0DDE4F_SteerAuxRpt__H_
#define _H_D8CC0A64881C99F414694EC75A0DDE4F_SteerAuxRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SteerAuxRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double raw_position_;
                ::DDS::Boolean raw_position_is_valid_;
                ::DDS::Double raw_torque_;
                ::DDS::Boolean raw_torque_is_valid_;
                ::DDS::Double rotation_rate_;
                ::DDS::Boolean rotation_rate_is_valid_;
                ::DDS::Boolean user_interaction_;
                ::DDS::Boolean user_interaction_is_valid_;
            };

            typedef DDS_DCPSStruct_var<SteerAuxRpt_> SteerAuxRpt__var;
            typedef DDS_DCPSStruct_out < SteerAuxRpt_> SteerAuxRpt__out;

        }

    }

}

#endif /* _H_D8CC0A64881C99F414694EC75A0DDE4F_SteerAuxRpt__H_ */
