#ifndef _H_57B6CBCCB4D6A203F72CE339C9756754_SteeringPIDRpt3_DCPS_H_
#define _H_57B6CBCCB4D6A203F72CE339C9756754_SteeringPIDRpt3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SteeringPIDRpt3_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SteeringPIDRpt3_TypeSupportInterface;

            typedef SteeringPIDRpt3_TypeSupportInterface * SteeringPIDRpt3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SteeringPIDRpt3_TypeSupportInterface> SteeringPIDRpt3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SteeringPIDRpt3_TypeSupportInterface> SteeringPIDRpt3_TypeSupportInterface_out;


            class SteeringPIDRpt3_DataWriter;

            typedef SteeringPIDRpt3_DataWriter * SteeringPIDRpt3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SteeringPIDRpt3_DataWriter> SteeringPIDRpt3_DataWriter_var;
            typedef DDS_DCPSInterface_out < SteeringPIDRpt3_DataWriter> SteeringPIDRpt3_DataWriter_out;


            class SteeringPIDRpt3_DataReader;

            typedef SteeringPIDRpt3_DataReader * SteeringPIDRpt3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SteeringPIDRpt3_DataReader> SteeringPIDRpt3_DataReader_var;
            typedef DDS_DCPSInterface_out < SteeringPIDRpt3_DataReader> SteeringPIDRpt3_DataReader_out;


            class SteeringPIDRpt3_DataReaderView;

            typedef SteeringPIDRpt3_DataReaderView * SteeringPIDRpt3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SteeringPIDRpt3_DataReaderView> SteeringPIDRpt3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SteeringPIDRpt3_DataReaderView> SteeringPIDRpt3_DataReaderView_out;

            struct SteeringPIDRpt3_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SteeringPIDRpt3_, struct SteeringPIDRpt3_Seq_uniq_> SteeringPIDRpt3_Seq;
            typedef DDS_DCPSSequence_var < SteeringPIDRpt3_Seq> SteeringPIDRpt3_Seq_var;
            typedef DDS_DCPSSequence_out < SteeringPIDRpt3_Seq> SteeringPIDRpt3_Seq_out;

            class  SteeringPIDRpt3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SteeringPIDRpt3_TypeSupportInterface_ptr _ptr_type;
                typedef SteeringPIDRpt3_TypeSupportInterface_var _var_type;

                static SteeringPIDRpt3_TypeSupportInterface_ptr _duplicate (SteeringPIDRpt3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringPIDRpt3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringPIDRpt3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SteeringPIDRpt3_TypeSupportInterface () {};
                ~SteeringPIDRpt3_TypeSupportInterface () {};
            private:
                SteeringPIDRpt3_TypeSupportInterface (const SteeringPIDRpt3_TypeSupportInterface &);
                SteeringPIDRpt3_TypeSupportInterface & operator = (const SteeringPIDRpt3_TypeSupportInterface &);
            };

            class  SteeringPIDRpt3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SteeringPIDRpt3_DataWriter_ptr _ptr_type;
                typedef SteeringPIDRpt3_DataWriter_var _var_type;

                static SteeringPIDRpt3_DataWriter_ptr _duplicate (SteeringPIDRpt3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringPIDRpt3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringPIDRpt3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SteeringPIDRpt3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SteeringPIDRpt3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SteeringPIDRpt3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SteeringPIDRpt3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SteeringPIDRpt3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SteeringPIDRpt3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SteeringPIDRpt3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SteeringPIDRpt3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SteeringPIDRpt3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SteeringPIDRpt3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SteeringPIDRpt3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringPIDRpt3_& instance_data) = 0;

            protected:
                SteeringPIDRpt3_DataWriter () {};
                ~SteeringPIDRpt3_DataWriter () {};
            private:
                SteeringPIDRpt3_DataWriter (const SteeringPIDRpt3_DataWriter &);
                SteeringPIDRpt3_DataWriter & operator = (const SteeringPIDRpt3_DataWriter &);
            };

            class  SteeringPIDRpt3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SteeringPIDRpt3_DataReader_ptr _ptr_type;
                typedef SteeringPIDRpt3_DataReader_var _var_type;

                static SteeringPIDRpt3_DataReader_ptr _duplicate (SteeringPIDRpt3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringPIDRpt3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringPIDRpt3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringPIDRpt3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringPIDRpt3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringPIDRpt3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringPIDRpt3_& instance) = 0;

            protected:
                SteeringPIDRpt3_DataReader () {};
                ~SteeringPIDRpt3_DataReader () {};
            private:
                SteeringPIDRpt3_DataReader (const SteeringPIDRpt3_DataReader &);
                SteeringPIDRpt3_DataReader & operator = (const SteeringPIDRpt3_DataReader &);
            };

            class  SteeringPIDRpt3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SteeringPIDRpt3_DataReaderView_ptr _ptr_type;
                typedef SteeringPIDRpt3_DataReaderView_var _var_type;

                static SteeringPIDRpt3_DataReaderView_ptr _duplicate (SteeringPIDRpt3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringPIDRpt3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringPIDRpt3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringPIDRpt3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringPIDRpt3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringPIDRpt3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringPIDRpt3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringPIDRpt3_& instance) = 0;

            protected:
                SteeringPIDRpt3_DataReaderView () {};
                ~SteeringPIDRpt3_DataReaderView () {};
            private:
                SteeringPIDRpt3_DataReaderView (const SteeringPIDRpt3_DataReaderView &);
                SteeringPIDRpt3_DataReaderView & operator = (const SteeringPIDRpt3_DataReaderView &);
            };
        }

    }

}

#endif
