#ifndef _H_A9450DD77E686DAD8D67F7AAD093BA02_SteeringPIDRpt4_DCPS_H_
#define _H_A9450DD77E686DAD8D67F7AAD093BA02_SteeringPIDRpt4_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SteeringPIDRpt4_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SteeringPIDRpt4_TypeSupportInterface;

            typedef SteeringPIDRpt4_TypeSupportInterface * SteeringPIDRpt4_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SteeringPIDRpt4_TypeSupportInterface> SteeringPIDRpt4_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SteeringPIDRpt4_TypeSupportInterface> SteeringPIDRpt4_TypeSupportInterface_out;


            class SteeringPIDRpt4_DataWriter;

            typedef SteeringPIDRpt4_DataWriter * SteeringPIDRpt4_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SteeringPIDRpt4_DataWriter> SteeringPIDRpt4_DataWriter_var;
            typedef DDS_DCPSInterface_out < SteeringPIDRpt4_DataWriter> SteeringPIDRpt4_DataWriter_out;


            class SteeringPIDRpt4_DataReader;

            typedef SteeringPIDRpt4_DataReader * SteeringPIDRpt4_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SteeringPIDRpt4_DataReader> SteeringPIDRpt4_DataReader_var;
            typedef DDS_DCPSInterface_out < SteeringPIDRpt4_DataReader> SteeringPIDRpt4_DataReader_out;


            class SteeringPIDRpt4_DataReaderView;

            typedef SteeringPIDRpt4_DataReaderView * SteeringPIDRpt4_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SteeringPIDRpt4_DataReaderView> SteeringPIDRpt4_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SteeringPIDRpt4_DataReaderView> SteeringPIDRpt4_DataReaderView_out;

            struct SteeringPIDRpt4_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SteeringPIDRpt4_, struct SteeringPIDRpt4_Seq_uniq_> SteeringPIDRpt4_Seq;
            typedef DDS_DCPSSequence_var < SteeringPIDRpt4_Seq> SteeringPIDRpt4_Seq_var;
            typedef DDS_DCPSSequence_out < SteeringPIDRpt4_Seq> SteeringPIDRpt4_Seq_out;

            class  SteeringPIDRpt4_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SteeringPIDRpt4_TypeSupportInterface_ptr _ptr_type;
                typedef SteeringPIDRpt4_TypeSupportInterface_var _var_type;

                static SteeringPIDRpt4_TypeSupportInterface_ptr _duplicate (SteeringPIDRpt4_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringPIDRpt4_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt4_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt4_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringPIDRpt4_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SteeringPIDRpt4_TypeSupportInterface () {};
                ~SteeringPIDRpt4_TypeSupportInterface () {};
            private:
                SteeringPIDRpt4_TypeSupportInterface (const SteeringPIDRpt4_TypeSupportInterface &);
                SteeringPIDRpt4_TypeSupportInterface & operator = (const SteeringPIDRpt4_TypeSupportInterface &);
            };

            class  SteeringPIDRpt4_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SteeringPIDRpt4_DataWriter_ptr _ptr_type;
                typedef SteeringPIDRpt4_DataWriter_var _var_type;

                static SteeringPIDRpt4_DataWriter_ptr _duplicate (SteeringPIDRpt4_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringPIDRpt4_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt4_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt4_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringPIDRpt4_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SteeringPIDRpt4_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SteeringPIDRpt4_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SteeringPIDRpt4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SteeringPIDRpt4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SteeringPIDRpt4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SteeringPIDRpt4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SteeringPIDRpt4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SteeringPIDRpt4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SteeringPIDRpt4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SteeringPIDRpt4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SteeringPIDRpt4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringPIDRpt4_& instance_data) = 0;

            protected:
                SteeringPIDRpt4_DataWriter () {};
                ~SteeringPIDRpt4_DataWriter () {};
            private:
                SteeringPIDRpt4_DataWriter (const SteeringPIDRpt4_DataWriter &);
                SteeringPIDRpt4_DataWriter & operator = (const SteeringPIDRpt4_DataWriter &);
            };

            class  SteeringPIDRpt4_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SteeringPIDRpt4_DataReader_ptr _ptr_type;
                typedef SteeringPIDRpt4_DataReader_var _var_type;

                static SteeringPIDRpt4_DataReader_ptr _duplicate (SteeringPIDRpt4_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringPIDRpt4_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt4_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt4_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringPIDRpt4_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringPIDRpt4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringPIDRpt4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringPIDRpt4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringPIDRpt4_& instance) = 0;

            protected:
                SteeringPIDRpt4_DataReader () {};
                ~SteeringPIDRpt4_DataReader () {};
            private:
                SteeringPIDRpt4_DataReader (const SteeringPIDRpt4_DataReader &);
                SteeringPIDRpt4_DataReader & operator = (const SteeringPIDRpt4_DataReader &);
            };

            class  SteeringPIDRpt4_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SteeringPIDRpt4_DataReaderView_ptr _ptr_type;
                typedef SteeringPIDRpt4_DataReaderView_var _var_type;

                static SteeringPIDRpt4_DataReaderView_ptr _duplicate (SteeringPIDRpt4_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringPIDRpt4_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt4_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringPIDRpt4_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringPIDRpt4_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringPIDRpt4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringPIDRpt4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringPIDRpt4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringPIDRpt4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringPIDRpt4_& instance) = 0;

            protected:
                SteeringPIDRpt4_DataReaderView () {};
                ~SteeringPIDRpt4_DataReaderView () {};
            private:
                SteeringPIDRpt4_DataReaderView (const SteeringPIDRpt4_DataReaderView &);
                SteeringPIDRpt4_DataReaderView & operator = (const SteeringPIDRpt4_DataReaderView &);
            };
        }

    }

}

#endif
