#ifndef _H_B4EB1E1109DB19ABBC725367657C455A_SystemCmdFloat_DCPS_H_
#define _H_B4EB1E1109DB19ABBC725367657C455A_SystemCmdFloat_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemCmdFloat_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemCmdFloat_TypeSupportInterface;

            typedef SystemCmdFloat_TypeSupportInterface * SystemCmdFloat_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemCmdFloat_TypeSupportInterface> SystemCmdFloat_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemCmdFloat_TypeSupportInterface> SystemCmdFloat_TypeSupportInterface_out;


            class SystemCmdFloat_DataWriter;

            typedef SystemCmdFloat_DataWriter * SystemCmdFloat_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemCmdFloat_DataWriter> SystemCmdFloat_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemCmdFloat_DataWriter> SystemCmdFloat_DataWriter_out;


            class SystemCmdFloat_DataReader;

            typedef SystemCmdFloat_DataReader * SystemCmdFloat_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemCmdFloat_DataReader> SystemCmdFloat_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemCmdFloat_DataReader> SystemCmdFloat_DataReader_out;


            class SystemCmdFloat_DataReaderView;

            typedef SystemCmdFloat_DataReaderView * SystemCmdFloat_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemCmdFloat_DataReaderView> SystemCmdFloat_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemCmdFloat_DataReaderView> SystemCmdFloat_DataReaderView_out;

            struct SystemCmdFloat_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemCmdFloat_, struct SystemCmdFloat_Seq_uniq_> SystemCmdFloat_Seq;
            typedef DDS_DCPSSequence_var < SystemCmdFloat_Seq> SystemCmdFloat_Seq_var;
            typedef DDS_DCPSSequence_out < SystemCmdFloat_Seq> SystemCmdFloat_Seq_out;

            class  SystemCmdFloat_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemCmdFloat_TypeSupportInterface_ptr _ptr_type;
                typedef SystemCmdFloat_TypeSupportInterface_var _var_type;

                static SystemCmdFloat_TypeSupportInterface_ptr _duplicate (SystemCmdFloat_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemCmdFloat_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemCmdFloat_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemCmdFloat_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemCmdFloat_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemCmdFloat_TypeSupportInterface () {};
                ~SystemCmdFloat_TypeSupportInterface () {};
            private:
                SystemCmdFloat_TypeSupportInterface (const SystemCmdFloat_TypeSupportInterface &);
                SystemCmdFloat_TypeSupportInterface & operator = (const SystemCmdFloat_TypeSupportInterface &);
            };

            class  SystemCmdFloat_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemCmdFloat_DataWriter_ptr _ptr_type;
                typedef SystemCmdFloat_DataWriter_var _var_type;

                static SystemCmdFloat_DataWriter_ptr _duplicate (SystemCmdFloat_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemCmdFloat_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemCmdFloat_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemCmdFloat_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemCmdFloat_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemCmdFloat_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemCmdFloat_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemCmdFloat_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemCmdFloat_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemCmdFloat_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemCmdFloat_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemCmdFloat_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemCmdFloat_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemCmdFloat_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemCmdFloat_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemCmdFloat_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemCmdFloat_& instance_data) = 0;

            protected:
                SystemCmdFloat_DataWriter () {};
                ~SystemCmdFloat_DataWriter () {};
            private:
                SystemCmdFloat_DataWriter (const SystemCmdFloat_DataWriter &);
                SystemCmdFloat_DataWriter & operator = (const SystemCmdFloat_DataWriter &);
            };

            class  SystemCmdFloat_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemCmdFloat_DataReader_ptr _ptr_type;
                typedef SystemCmdFloat_DataReader_var _var_type;

                static SystemCmdFloat_DataReader_ptr _duplicate (SystemCmdFloat_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemCmdFloat_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemCmdFloat_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemCmdFloat_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemCmdFloat_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemCmdFloat_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemCmdFloat_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemCmdFloat_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemCmdFloat_& instance) = 0;

            protected:
                SystemCmdFloat_DataReader () {};
                ~SystemCmdFloat_DataReader () {};
            private:
                SystemCmdFloat_DataReader (const SystemCmdFloat_DataReader &);
                SystemCmdFloat_DataReader & operator = (const SystemCmdFloat_DataReader &);
            };

            class  SystemCmdFloat_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemCmdFloat_DataReaderView_ptr _ptr_type;
                typedef SystemCmdFloat_DataReaderView_var _var_type;

                static SystemCmdFloat_DataReaderView_ptr _duplicate (SystemCmdFloat_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemCmdFloat_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemCmdFloat_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemCmdFloat_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemCmdFloat_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemCmdFloat_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemCmdFloat_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemCmdFloat_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemCmdFloat_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemCmdFloat_& instance) = 0;

            protected:
                SystemCmdFloat_DataReaderView () {};
                ~SystemCmdFloat_DataReaderView () {};
            private:
                SystemCmdFloat_DataReaderView (const SystemCmdFloat_DataReaderView &);
                SystemCmdFloat_DataReaderView & operator = (const SystemCmdFloat_DataReaderView &);
            };
        }

    }

}

#endif
