#ifndef _H_8F93BC45B2B0498683E705CF45AFCF85_SystemCmdInt__H_
#define _H_8F93BC45B2B0498683E705CF45AFCF85_SystemCmdInt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SystemCmdInt_Constants
            {
                const ::DDS::UShort CRUISE_CONTROL_NONE_ = 0U;

                const ::DDS::UShort CRUISE_CONTROL_CNCL_ = 1U;

                const ::DDS::UShort CRUISE_CONTROL_ACC_FURTHER_ = 2U;

                const ::DDS::UShort CRUISE_CONTROL_ACC_CLOSER_ = 3U;

                const ::DDS::UShort CRUISE_CONTROL_SET_DEC_ = 4U;

                const ::DDS::UShort CRUISE_CONTROL_RES_INC_ = 5U;

                const ::DDS::UShort DASH_CONTROL_NONE_ = 0U;

                const ::DDS::UShort DASH_CONTROL_OK_ = 1U;

                const ::DDS::UShort DASH_CONTROL_LEFT_ = 2U;

                const ::DDS::UShort DASH_CONTROL_RIGHT_ = 3U;

                const ::DDS::UShort DASH_CONTROL_UP_ = 4U;

                const ::DDS::UShort DASH_CONTROL_DOWN_ = 5U;

                const ::DDS::UShort HEADLIGHTS_OFF_ = 0U;

                const ::DDS::UShort HEADLIGHTS_PARKING_ONLY_ = 1U;

                const ::DDS::UShort HEADLIGHTS_MANUAL_LOW_ = 2U;

                const ::DDS::UShort HEADLIGHTS_MANUAL_HIGH_ = 3U;

                const ::DDS::UShort HEADLIGHTS_AUTO_LOW_ = 4U;

                const ::DDS::UShort HEADLIGHTS_AUTO_HIGH_ = 5U;

                const ::DDS::UShort MEDIA_CONTROL_NONE_ = 0U;

                const ::DDS::UShort MEDIA_CONTROL_VOICE_COMMAND_ = 1U;

                const ::DDS::UShort MEDIA_CONTROL_MUTE_ = 2U;

                const ::DDS::UShort MEDIA_CONTROL_PREV_TRACK_ANSWER_ = 3U;

                const ::DDS::UShort MEDIA_CONTROL_NEXT_TRACK_HANG_UP_ = 4U;

                const ::DDS::UShort MEDIA_CONTROL_VOL_UP_ = 5U;

                const ::DDS::UShort MEDIA_CONTROL_VOL_DOWN_ = 6U;

                const ::DDS::UShort SHIFT_PARK_ = 0U;

                const ::DDS::UShort SHIFT_REVERSE_ = 1U;

                const ::DDS::UShort SHIFT_NEUTRAL_ = 2U;

                const ::DDS::UShort SHIFT_HIGH_ = 3U;

                const ::DDS::UShort SHIFT_FORWARD_ = 3U;

                const ::DDS::UShort SHIFT_LOW_ = 4U;

                const ::DDS::UShort SHIFT_NONE_ = 7U;

                const ::DDS::UShort TURN_RIGHT_ = 0U;

                const ::DDS::UShort TURN_NONE_ = 1U;

                const ::DDS::UShort TURN_LEFT_ = 2U;

                const ::DDS::UShort TURN_HAZARDS_ = 3U;

                const ::DDS::UShort DOOR_NEUTRAL_ = 0U;

                const ::DDS::UShort DOOR_OPEN_ = 1U;

                const ::DDS::UShort DOOR_CLOSE_ = 2U;

                const ::DDS::UShort WIPERS_OFF_ = 0U;

                const ::DDS::UShort WIPERS_INT_1_ = 1U;

                const ::DDS::UShort WIPERS_INT_2_ = 2U;

                const ::DDS::UShort WIPERS_INT_3_ = 3U;

                const ::DDS::UShort WIPERS_INT_4_ = 4U;

                const ::DDS::UShort WIPERS_INT_5_ = 5U;

                const ::DDS::UShort WIPERS_INT_6_ = 6U;

                const ::DDS::UShort WIPERS_MEDIUM_ = 7U;

                const ::DDS::UShort WIPERS_HIGH_ = 8U;

            }

            struct  SystemCmdInt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean enable_;
                ::DDS::Boolean ignore_overrides_;
                ::DDS::Boolean clear_override_;
                ::DDS::Boolean clear_faults_;
                ::DDS::UShort command_;
            };

            typedef DDS_DCPSStruct_var<SystemCmdInt_> SystemCmdInt__var;
            typedef DDS_DCPSStruct_out < SystemCmdInt_> SystemCmdInt__out;

        }

    }

}

#endif /* _H_8F93BC45B2B0498683E705CF45AFCF85_SystemCmdInt__H_ */
