#ifndef _H_8F93BC45B2B0498683E705CF45AFCF85_SystemCmdInt_DCPS_H_
#define _H_8F93BC45B2B0498683E705CF45AFCF85_SystemCmdInt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemCmdInt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemCmdInt_TypeSupportInterface;

            typedef SystemCmdInt_TypeSupportInterface * SystemCmdInt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemCmdInt_TypeSupportInterface> SystemCmdInt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemCmdInt_TypeSupportInterface> SystemCmdInt_TypeSupportInterface_out;


            class SystemCmdInt_DataWriter;

            typedef SystemCmdInt_DataWriter * SystemCmdInt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemCmdInt_DataWriter> SystemCmdInt_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemCmdInt_DataWriter> SystemCmdInt_DataWriter_out;


            class SystemCmdInt_DataReader;

            typedef SystemCmdInt_DataReader * SystemCmdInt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemCmdInt_DataReader> SystemCmdInt_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemCmdInt_DataReader> SystemCmdInt_DataReader_out;


            class SystemCmdInt_DataReaderView;

            typedef SystemCmdInt_DataReaderView * SystemCmdInt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemCmdInt_DataReaderView> SystemCmdInt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemCmdInt_DataReaderView> SystemCmdInt_DataReaderView_out;

            struct SystemCmdInt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemCmdInt_, struct SystemCmdInt_Seq_uniq_> SystemCmdInt_Seq;
            typedef DDS_DCPSSequence_var < SystemCmdInt_Seq> SystemCmdInt_Seq_var;
            typedef DDS_DCPSSequence_out < SystemCmdInt_Seq> SystemCmdInt_Seq_out;

            class  SystemCmdInt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemCmdInt_TypeSupportInterface_ptr _ptr_type;
                typedef SystemCmdInt_TypeSupportInterface_var _var_type;

                static SystemCmdInt_TypeSupportInterface_ptr _duplicate (SystemCmdInt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemCmdInt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemCmdInt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemCmdInt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemCmdInt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemCmdInt_TypeSupportInterface () {};
                ~SystemCmdInt_TypeSupportInterface () {};
            private:
                SystemCmdInt_TypeSupportInterface (const SystemCmdInt_TypeSupportInterface &);
                SystemCmdInt_TypeSupportInterface & operator = (const SystemCmdInt_TypeSupportInterface &);
            };

            class  SystemCmdInt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemCmdInt_DataWriter_ptr _ptr_type;
                typedef SystemCmdInt_DataWriter_var _var_type;

                static SystemCmdInt_DataWriter_ptr _duplicate (SystemCmdInt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemCmdInt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemCmdInt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemCmdInt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemCmdInt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemCmdInt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemCmdInt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemCmdInt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemCmdInt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemCmdInt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemCmdInt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemCmdInt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemCmdInt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemCmdInt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemCmdInt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemCmdInt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemCmdInt_& instance_data) = 0;

            protected:
                SystemCmdInt_DataWriter () {};
                ~SystemCmdInt_DataWriter () {};
            private:
                SystemCmdInt_DataWriter (const SystemCmdInt_DataWriter &);
                SystemCmdInt_DataWriter & operator = (const SystemCmdInt_DataWriter &);
            };

            class  SystemCmdInt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemCmdInt_DataReader_ptr _ptr_type;
                typedef SystemCmdInt_DataReader_var _var_type;

                static SystemCmdInt_DataReader_ptr _duplicate (SystemCmdInt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemCmdInt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemCmdInt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemCmdInt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemCmdInt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemCmdInt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemCmdInt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemCmdInt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemCmdInt_& instance) = 0;

            protected:
                SystemCmdInt_DataReader () {};
                ~SystemCmdInt_DataReader () {};
            private:
                SystemCmdInt_DataReader (const SystemCmdInt_DataReader &);
                SystemCmdInt_DataReader & operator = (const SystemCmdInt_DataReader &);
            };

            class  SystemCmdInt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemCmdInt_DataReaderView_ptr _ptr_type;
                typedef SystemCmdInt_DataReaderView_var _var_type;

                static SystemCmdInt_DataReaderView_ptr _duplicate (SystemCmdInt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemCmdInt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemCmdInt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemCmdInt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemCmdInt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemCmdInt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemCmdInt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemCmdInt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemCmdInt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemCmdInt_& instance) = 0;

            protected:
                SystemCmdInt_DataReaderView () {};
                ~SystemCmdInt_DataReaderView () {};
            private:
                SystemCmdInt_DataReaderView (const SystemCmdInt_DataReaderView &);
                SystemCmdInt_DataReaderView & operator = (const SystemCmdInt_DataReaderView &);
            };
        }

    }

}

#endif
