#ifndef _H_0CB7A0AC6177BA765E9324F738655E8F_SystemRptBool_DCPS_H_
#define _H_0CB7A0AC6177BA765E9324F738655E8F_SystemRptBool_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemRptBool_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemRptBool_TypeSupportInterface;

            typedef SystemRptBool_TypeSupportInterface * SystemRptBool_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemRptBool_TypeSupportInterface> SystemRptBool_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemRptBool_TypeSupportInterface> SystemRptBool_TypeSupportInterface_out;


            class SystemRptBool_DataWriter;

            typedef SystemRptBool_DataWriter * SystemRptBool_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemRptBool_DataWriter> SystemRptBool_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemRptBool_DataWriter> SystemRptBool_DataWriter_out;


            class SystemRptBool_DataReader;

            typedef SystemRptBool_DataReader * SystemRptBool_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemRptBool_DataReader> SystemRptBool_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemRptBool_DataReader> SystemRptBool_DataReader_out;


            class SystemRptBool_DataReaderView;

            typedef SystemRptBool_DataReaderView * SystemRptBool_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemRptBool_DataReaderView> SystemRptBool_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemRptBool_DataReaderView> SystemRptBool_DataReaderView_out;

            struct SystemRptBool_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemRptBool_, struct SystemRptBool_Seq_uniq_> SystemRptBool_Seq;
            typedef DDS_DCPSSequence_var < SystemRptBool_Seq> SystemRptBool_Seq_var;
            typedef DDS_DCPSSequence_out < SystemRptBool_Seq> SystemRptBool_Seq_out;

            class  SystemRptBool_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemRptBool_TypeSupportInterface_ptr _ptr_type;
                typedef SystemRptBool_TypeSupportInterface_var _var_type;

                static SystemRptBool_TypeSupportInterface_ptr _duplicate (SystemRptBool_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemRptBool_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemRptBool_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemRptBool_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemRptBool_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemRptBool_TypeSupportInterface () {};
                ~SystemRptBool_TypeSupportInterface () {};
            private:
                SystemRptBool_TypeSupportInterface (const SystemRptBool_TypeSupportInterface &);
                SystemRptBool_TypeSupportInterface & operator = (const SystemRptBool_TypeSupportInterface &);
            };

            class  SystemRptBool_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemRptBool_DataWriter_ptr _ptr_type;
                typedef SystemRptBool_DataWriter_var _var_type;

                static SystemRptBool_DataWriter_ptr _duplicate (SystemRptBool_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemRptBool_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemRptBool_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemRptBool_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemRptBool_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemRptBool_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemRptBool_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemRptBool_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemRptBool_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemRptBool_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemRptBool_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemRptBool_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemRptBool_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemRptBool_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemRptBool_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemRptBool_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemRptBool_& instance_data) = 0;

            protected:
                SystemRptBool_DataWriter () {};
                ~SystemRptBool_DataWriter () {};
            private:
                SystemRptBool_DataWriter (const SystemRptBool_DataWriter &);
                SystemRptBool_DataWriter & operator = (const SystemRptBool_DataWriter &);
            };

            class  SystemRptBool_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemRptBool_DataReader_ptr _ptr_type;
                typedef SystemRptBool_DataReader_var _var_type;

                static SystemRptBool_DataReader_ptr _duplicate (SystemRptBool_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemRptBool_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemRptBool_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemRptBool_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemRptBool_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemRptBool_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemRptBool_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemRptBool_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemRptBool_& instance) = 0;

            protected:
                SystemRptBool_DataReader () {};
                ~SystemRptBool_DataReader () {};
            private:
                SystemRptBool_DataReader (const SystemRptBool_DataReader &);
                SystemRptBool_DataReader & operator = (const SystemRptBool_DataReader &);
            };

            class  SystemRptBool_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemRptBool_DataReaderView_ptr _ptr_type;
                typedef SystemRptBool_DataReaderView_var _var_type;

                static SystemRptBool_DataReaderView_ptr _duplicate (SystemRptBool_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemRptBool_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemRptBool_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemRptBool_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemRptBool_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemRptBool_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemRptBool_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemRptBool_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemRptBool_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemRptBool_& instance) = 0;

            protected:
                SystemRptBool_DataReaderView () {};
                ~SystemRptBool_DataReaderView () {};
            private:
                SystemRptBool_DataReaderView (const SystemRptBool_DataReaderView &);
                SystemRptBool_DataReaderView & operator = (const SystemRptBool_DataReaderView &);
            };
        }

    }

}

#endif
