#ifndef _H_08F197ED0F02F00BF1A854189C273126_SystemRptFloat__H_
#define _H_08F197ED0F02F00BF1A854189C273126_SystemRptFloat__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SystemRptFloat_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean enabled_;
                ::DDS::Boolean override_active_;
                ::DDS::Boolean command_output_fault_;
                ::DDS::Boolean input_output_fault_;
                ::DDS::Boolean output_reported_fault_;
                ::DDS::Boolean pacmod_fault_;
                ::DDS::Boolean vehicle_fault_;
                ::DDS::Double manual_input_;
                ::DDS::Double command_;
                ::DDS::Double output_;
            };

            typedef DDS_DCPSStruct_var<SystemRptFloat_> SystemRptFloat__var;
            typedef DDS_DCPSStruct_out < SystemRptFloat_> SystemRptFloat__out;

        }

    }

}

#endif /* _H_08F197ED0F02F00BF1A854189C273126_SystemRptFloat__H_ */
