#ifndef _H_F127C8724A9692DF2AE3CB04599E2299_SystemRptInt_DCPS_H_
#define _H_F127C8724A9692DF2AE3CB04599E2299_SystemRptInt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SystemRptInt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SystemRptInt_TypeSupportInterface;

            typedef SystemRptInt_TypeSupportInterface * SystemRptInt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SystemRptInt_TypeSupportInterface> SystemRptInt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SystemRptInt_TypeSupportInterface> SystemRptInt_TypeSupportInterface_out;


            class SystemRptInt_DataWriter;

            typedef SystemRptInt_DataWriter * SystemRptInt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SystemRptInt_DataWriter> SystemRptInt_DataWriter_var;
            typedef DDS_DCPSInterface_out < SystemRptInt_DataWriter> SystemRptInt_DataWriter_out;


            class SystemRptInt_DataReader;

            typedef SystemRptInt_DataReader * SystemRptInt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SystemRptInt_DataReader> SystemRptInt_DataReader_var;
            typedef DDS_DCPSInterface_out < SystemRptInt_DataReader> SystemRptInt_DataReader_out;


            class SystemRptInt_DataReaderView;

            typedef SystemRptInt_DataReaderView * SystemRptInt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SystemRptInt_DataReaderView> SystemRptInt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SystemRptInt_DataReaderView> SystemRptInt_DataReaderView_out;

            struct SystemRptInt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SystemRptInt_, struct SystemRptInt_Seq_uniq_> SystemRptInt_Seq;
            typedef DDS_DCPSSequence_var < SystemRptInt_Seq> SystemRptInt_Seq_var;
            typedef DDS_DCPSSequence_out < SystemRptInt_Seq> SystemRptInt_Seq_out;

            class  SystemRptInt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SystemRptInt_TypeSupportInterface_ptr _ptr_type;
                typedef SystemRptInt_TypeSupportInterface_var _var_type;

                static SystemRptInt_TypeSupportInterface_ptr _duplicate (SystemRptInt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemRptInt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SystemRptInt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemRptInt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemRptInt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SystemRptInt_TypeSupportInterface () {};
                ~SystemRptInt_TypeSupportInterface () {};
            private:
                SystemRptInt_TypeSupportInterface (const SystemRptInt_TypeSupportInterface &);
                SystemRptInt_TypeSupportInterface & operator = (const SystemRptInt_TypeSupportInterface &);
            };

            class  SystemRptInt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SystemRptInt_DataWriter_ptr _ptr_type;
                typedef SystemRptInt_DataWriter_var _var_type;

                static SystemRptInt_DataWriter_ptr _duplicate (SystemRptInt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemRptInt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SystemRptInt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemRptInt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemRptInt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SystemRptInt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SystemRptInt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SystemRptInt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SystemRptInt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SystemRptInt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SystemRptInt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SystemRptInt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SystemRptInt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SystemRptInt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SystemRptInt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SystemRptInt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemRptInt_& instance_data) = 0;

            protected:
                SystemRptInt_DataWriter () {};
                ~SystemRptInt_DataWriter () {};
            private:
                SystemRptInt_DataWriter (const SystemRptInt_DataWriter &);
                SystemRptInt_DataWriter & operator = (const SystemRptInt_DataWriter &);
            };

            class  SystemRptInt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SystemRptInt_DataReader_ptr _ptr_type;
                typedef SystemRptInt_DataReader_var _var_type;

                static SystemRptInt_DataReader_ptr _duplicate (SystemRptInt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemRptInt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SystemRptInt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemRptInt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemRptInt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemRptInt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemRptInt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemRptInt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemRptInt_& instance) = 0;

            protected:
                SystemRptInt_DataReader () {};
                ~SystemRptInt_DataReader () {};
            private:
                SystemRptInt_DataReader (const SystemRptInt_DataReader &);
                SystemRptInt_DataReader & operator = (const SystemRptInt_DataReader &);
            };

            class  SystemRptInt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SystemRptInt_DataReaderView_ptr _ptr_type;
                typedef SystemRptInt_DataReaderView_var _var_type;

                static SystemRptInt_DataReaderView_ptr _duplicate (SystemRptInt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SystemRptInt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SystemRptInt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SystemRptInt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SystemRptInt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SystemRptInt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SystemRptInt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SystemRptInt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SystemRptInt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SystemRptInt_& instance) = 0;

            protected:
                SystemRptInt_DataReaderView () {};
                ~SystemRptInt_DataReaderView () {};
            private:
                SystemRptInt_DataReaderView (const SystemRptInt_DataReaderView &);
                SystemRptInt_DataReaderView & operator = (const SystemRptInt_DataReaderView &);
            };
        }

    }

}

#endif
