#ifndef _H_35A183CDECC6DC3749EA379EC0178210_TurnAuxRpt_DCPS_H_
#define _H_35A183CDECC6DC3749EA379EC0178210_TurnAuxRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TurnAuxRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TurnAuxRpt_TypeSupportInterface;

            typedef TurnAuxRpt_TypeSupportInterface * TurnAuxRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TurnAuxRpt_TypeSupportInterface> TurnAuxRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TurnAuxRpt_TypeSupportInterface> TurnAuxRpt_TypeSupportInterface_out;


            class TurnAuxRpt_DataWriter;

            typedef TurnAuxRpt_DataWriter * TurnAuxRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TurnAuxRpt_DataWriter> TurnAuxRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < TurnAuxRpt_DataWriter> TurnAuxRpt_DataWriter_out;


            class TurnAuxRpt_DataReader;

            typedef TurnAuxRpt_DataReader * TurnAuxRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TurnAuxRpt_DataReader> TurnAuxRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < TurnAuxRpt_DataReader> TurnAuxRpt_DataReader_out;


            class TurnAuxRpt_DataReaderView;

            typedef TurnAuxRpt_DataReaderView * TurnAuxRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TurnAuxRpt_DataReaderView> TurnAuxRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TurnAuxRpt_DataReaderView> TurnAuxRpt_DataReaderView_out;

            struct TurnAuxRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TurnAuxRpt_, struct TurnAuxRpt_Seq_uniq_> TurnAuxRpt_Seq;
            typedef DDS_DCPSSequence_var < TurnAuxRpt_Seq> TurnAuxRpt_Seq_var;
            typedef DDS_DCPSSequence_out < TurnAuxRpt_Seq> TurnAuxRpt_Seq_out;

            class  TurnAuxRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TurnAuxRpt_TypeSupportInterface_ptr _ptr_type;
                typedef TurnAuxRpt_TypeSupportInterface_var _var_type;

                static TurnAuxRpt_TypeSupportInterface_ptr _duplicate (TurnAuxRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnAuxRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TurnAuxRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnAuxRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnAuxRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TurnAuxRpt_TypeSupportInterface () {};
                ~TurnAuxRpt_TypeSupportInterface () {};
            private:
                TurnAuxRpt_TypeSupportInterface (const TurnAuxRpt_TypeSupportInterface &);
                TurnAuxRpt_TypeSupportInterface & operator = (const TurnAuxRpt_TypeSupportInterface &);
            };

            class  TurnAuxRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TurnAuxRpt_DataWriter_ptr _ptr_type;
                typedef TurnAuxRpt_DataWriter_var _var_type;

                static TurnAuxRpt_DataWriter_ptr _duplicate (TurnAuxRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnAuxRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TurnAuxRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnAuxRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnAuxRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TurnAuxRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TurnAuxRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TurnAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TurnAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TurnAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TurnAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TurnAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TurnAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TurnAuxRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TurnAuxRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TurnAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnAuxRpt_& instance_data) = 0;

            protected:
                TurnAuxRpt_DataWriter () {};
                ~TurnAuxRpt_DataWriter () {};
            private:
                TurnAuxRpt_DataWriter (const TurnAuxRpt_DataWriter &);
                TurnAuxRpt_DataWriter & operator = (const TurnAuxRpt_DataWriter &);
            };

            class  TurnAuxRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TurnAuxRpt_DataReader_ptr _ptr_type;
                typedef TurnAuxRpt_DataReader_var _var_type;

                static TurnAuxRpt_DataReader_ptr _duplicate (TurnAuxRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnAuxRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TurnAuxRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnAuxRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnAuxRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TurnAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TurnAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TurnAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnAuxRpt_& instance) = 0;

            protected:
                TurnAuxRpt_DataReader () {};
                ~TurnAuxRpt_DataReader () {};
            private:
                TurnAuxRpt_DataReader (const TurnAuxRpt_DataReader &);
                TurnAuxRpt_DataReader & operator = (const TurnAuxRpt_DataReader &);
            };

            class  TurnAuxRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TurnAuxRpt_DataReaderView_ptr _ptr_type;
                typedef TurnAuxRpt_DataReaderView_var _var_type;

                static TurnAuxRpt_DataReaderView_ptr _duplicate (TurnAuxRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnAuxRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TurnAuxRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnAuxRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnAuxRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TurnAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TurnAuxRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TurnAuxRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TurnAuxRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnAuxRpt_& instance) = 0;

            protected:
                TurnAuxRpt_DataReaderView () {};
                ~TurnAuxRpt_DataReaderView () {};
            private:
                TurnAuxRpt_DataReaderView (const TurnAuxRpt_DataReaderView &);
                TurnAuxRpt_DataReaderView & operator = (const TurnAuxRpt_DataReaderView &);
            };
        }

    }

}

#endif
