#ifndef _H_E904C24B5F79F49353132C11F6E68ABB_VehicleDynamicsRpt_DCPS_H_
#define _H_E904C24B5F79F49353132C11F6E68ABB_VehicleDynamicsRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleDynamicsRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleDynamicsRpt_TypeSupportInterface;

            typedef VehicleDynamicsRpt_TypeSupportInterface * VehicleDynamicsRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleDynamicsRpt_TypeSupportInterface> VehicleDynamicsRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleDynamicsRpt_TypeSupportInterface> VehicleDynamicsRpt_TypeSupportInterface_out;


            class VehicleDynamicsRpt_DataWriter;

            typedef VehicleDynamicsRpt_DataWriter * VehicleDynamicsRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleDynamicsRpt_DataWriter> VehicleDynamicsRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleDynamicsRpt_DataWriter> VehicleDynamicsRpt_DataWriter_out;


            class VehicleDynamicsRpt_DataReader;

            typedef VehicleDynamicsRpt_DataReader * VehicleDynamicsRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleDynamicsRpt_DataReader> VehicleDynamicsRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleDynamicsRpt_DataReader> VehicleDynamicsRpt_DataReader_out;


            class VehicleDynamicsRpt_DataReaderView;

            typedef VehicleDynamicsRpt_DataReaderView * VehicleDynamicsRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleDynamicsRpt_DataReaderView> VehicleDynamicsRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleDynamicsRpt_DataReaderView> VehicleDynamicsRpt_DataReaderView_out;

            struct VehicleDynamicsRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleDynamicsRpt_, struct VehicleDynamicsRpt_Seq_uniq_> VehicleDynamicsRpt_Seq;
            typedef DDS_DCPSSequence_var < VehicleDynamicsRpt_Seq> VehicleDynamicsRpt_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleDynamicsRpt_Seq> VehicleDynamicsRpt_Seq_out;

            class  VehicleDynamicsRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleDynamicsRpt_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleDynamicsRpt_TypeSupportInterface_var _var_type;

                static VehicleDynamicsRpt_TypeSupportInterface_ptr _duplicate (VehicleDynamicsRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleDynamicsRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleDynamicsRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleDynamicsRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleDynamicsRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleDynamicsRpt_TypeSupportInterface () {};
                ~VehicleDynamicsRpt_TypeSupportInterface () {};
            private:
                VehicleDynamicsRpt_TypeSupportInterface (const VehicleDynamicsRpt_TypeSupportInterface &);
                VehicleDynamicsRpt_TypeSupportInterface & operator = (const VehicleDynamicsRpt_TypeSupportInterface &);
            };

            class  VehicleDynamicsRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleDynamicsRpt_DataWriter_ptr _ptr_type;
                typedef VehicleDynamicsRpt_DataWriter_var _var_type;

                static VehicleDynamicsRpt_DataWriter_ptr _duplicate (VehicleDynamicsRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleDynamicsRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleDynamicsRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleDynamicsRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleDynamicsRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleDynamicsRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleDynamicsRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleDynamicsRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleDynamicsRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleDynamicsRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleDynamicsRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleDynamicsRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleDynamicsRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleDynamicsRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleDynamicsRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleDynamicsRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleDynamicsRpt_& instance_data) = 0;

            protected:
                VehicleDynamicsRpt_DataWriter () {};
                ~VehicleDynamicsRpt_DataWriter () {};
            private:
                VehicleDynamicsRpt_DataWriter (const VehicleDynamicsRpt_DataWriter &);
                VehicleDynamicsRpt_DataWriter & operator = (const VehicleDynamicsRpt_DataWriter &);
            };

            class  VehicleDynamicsRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleDynamicsRpt_DataReader_ptr _ptr_type;
                typedef VehicleDynamicsRpt_DataReader_var _var_type;

                static VehicleDynamicsRpt_DataReader_ptr _duplicate (VehicleDynamicsRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleDynamicsRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleDynamicsRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleDynamicsRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleDynamicsRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleDynamicsRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleDynamicsRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleDynamicsRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleDynamicsRpt_& instance) = 0;

            protected:
                VehicleDynamicsRpt_DataReader () {};
                ~VehicleDynamicsRpt_DataReader () {};
            private:
                VehicleDynamicsRpt_DataReader (const VehicleDynamicsRpt_DataReader &);
                VehicleDynamicsRpt_DataReader & operator = (const VehicleDynamicsRpt_DataReader &);
            };

            class  VehicleDynamicsRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleDynamicsRpt_DataReaderView_ptr _ptr_type;
                typedef VehicleDynamicsRpt_DataReaderView_var _var_type;

                static VehicleDynamicsRpt_DataReaderView_ptr _duplicate (VehicleDynamicsRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleDynamicsRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleDynamicsRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleDynamicsRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleDynamicsRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleDynamicsRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleDynamicsRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleDynamicsRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleDynamicsRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleDynamicsRpt_& instance) = 0;

            protected:
                VehicleDynamicsRpt_DataReaderView () {};
                ~VehicleDynamicsRpt_DataReaderView () {};
            private:
                VehicleDynamicsRpt_DataReaderView (const VehicleDynamicsRpt_DataReaderView &);
                VehicleDynamicsRpt_DataReaderView & operator = (const VehicleDynamicsRpt_DataReaderView &);
            };
        }

    }

}

#endif
