#ifndef _H_D57E9C1D7D028643BF15C2B266A80308_VehicleSpecificRpt1_DCPS_H_
#define _H_D57E9C1D7D028643BF15C2B266A80308_VehicleSpecificRpt1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleSpecificRpt1_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleSpecificRpt1_TypeSupportInterface;

            typedef VehicleSpecificRpt1_TypeSupportInterface * VehicleSpecificRpt1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleSpecificRpt1_TypeSupportInterface> VehicleSpecificRpt1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleSpecificRpt1_TypeSupportInterface> VehicleSpecificRpt1_TypeSupportInterface_out;


            class VehicleSpecificRpt1_DataWriter;

            typedef VehicleSpecificRpt1_DataWriter * VehicleSpecificRpt1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleSpecificRpt1_DataWriter> VehicleSpecificRpt1_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleSpecificRpt1_DataWriter> VehicleSpecificRpt1_DataWriter_out;


            class VehicleSpecificRpt1_DataReader;

            typedef VehicleSpecificRpt1_DataReader * VehicleSpecificRpt1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleSpecificRpt1_DataReader> VehicleSpecificRpt1_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleSpecificRpt1_DataReader> VehicleSpecificRpt1_DataReader_out;


            class VehicleSpecificRpt1_DataReaderView;

            typedef VehicleSpecificRpt1_DataReaderView * VehicleSpecificRpt1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleSpecificRpt1_DataReaderView> VehicleSpecificRpt1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleSpecificRpt1_DataReaderView> VehicleSpecificRpt1_DataReaderView_out;

            struct VehicleSpecificRpt1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleSpecificRpt1_, struct VehicleSpecificRpt1_Seq_uniq_> VehicleSpecificRpt1_Seq;
            typedef DDS_DCPSSequence_var < VehicleSpecificRpt1_Seq> VehicleSpecificRpt1_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleSpecificRpt1_Seq> VehicleSpecificRpt1_Seq_out;

            class  VehicleSpecificRpt1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleSpecificRpt1_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleSpecificRpt1_TypeSupportInterface_var _var_type;

                static VehicleSpecificRpt1_TypeSupportInterface_ptr _duplicate (VehicleSpecificRpt1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleSpecificRpt1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleSpecificRpt1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleSpecificRpt1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleSpecificRpt1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleSpecificRpt1_TypeSupportInterface () {};
                ~VehicleSpecificRpt1_TypeSupportInterface () {};
            private:
                VehicleSpecificRpt1_TypeSupportInterface (const VehicleSpecificRpt1_TypeSupportInterface &);
                VehicleSpecificRpt1_TypeSupportInterface & operator = (const VehicleSpecificRpt1_TypeSupportInterface &);
            };

            class  VehicleSpecificRpt1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleSpecificRpt1_DataWriter_ptr _ptr_type;
                typedef VehicleSpecificRpt1_DataWriter_var _var_type;

                static VehicleSpecificRpt1_DataWriter_ptr _duplicate (VehicleSpecificRpt1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleSpecificRpt1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleSpecificRpt1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleSpecificRpt1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleSpecificRpt1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleSpecificRpt1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleSpecificRpt1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleSpecificRpt1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleSpecificRpt1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleSpecificRpt1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleSpecificRpt1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleSpecificRpt1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleSpecificRpt1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleSpecificRpt1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleSpecificRpt1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleSpecificRpt1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleSpecificRpt1_& instance_data) = 0;

            protected:
                VehicleSpecificRpt1_DataWriter () {};
                ~VehicleSpecificRpt1_DataWriter () {};
            private:
                VehicleSpecificRpt1_DataWriter (const VehicleSpecificRpt1_DataWriter &);
                VehicleSpecificRpt1_DataWriter & operator = (const VehicleSpecificRpt1_DataWriter &);
            };

            class  VehicleSpecificRpt1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleSpecificRpt1_DataReader_ptr _ptr_type;
                typedef VehicleSpecificRpt1_DataReader_var _var_type;

                static VehicleSpecificRpt1_DataReader_ptr _duplicate (VehicleSpecificRpt1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleSpecificRpt1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleSpecificRpt1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleSpecificRpt1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleSpecificRpt1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleSpecificRpt1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleSpecificRpt1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleSpecificRpt1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleSpecificRpt1_& instance) = 0;

            protected:
                VehicleSpecificRpt1_DataReader () {};
                ~VehicleSpecificRpt1_DataReader () {};
            private:
                VehicleSpecificRpt1_DataReader (const VehicleSpecificRpt1_DataReader &);
                VehicleSpecificRpt1_DataReader & operator = (const VehicleSpecificRpt1_DataReader &);
            };

            class  VehicleSpecificRpt1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleSpecificRpt1_DataReaderView_ptr _ptr_type;
                typedef VehicleSpecificRpt1_DataReaderView_var _var_type;

                static VehicleSpecificRpt1_DataReaderView_ptr _duplicate (VehicleSpecificRpt1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleSpecificRpt1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleSpecificRpt1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleSpecificRpt1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleSpecificRpt1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleSpecificRpt1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleSpecificRpt1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleSpecificRpt1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleSpecificRpt1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleSpecificRpt1_& instance) = 0;

            protected:
                VehicleSpecificRpt1_DataReaderView () {};
                ~VehicleSpecificRpt1_DataReaderView () {};
            private:
                VehicleSpecificRpt1_DataReaderView (const VehicleSpecificRpt1_DataReaderView &);
                VehicleSpecificRpt1_DataReaderView & operator = (const VehicleSpecificRpt1_DataReaderView &);
            };
        }

    }

}

#endif
