#ifndef _H_E136C125D7C85614837BB0FFCCF0E3EF_WheelSpeedRpt__H_
#define _H_E136C125D7C85614837BB0FFCCF0E3EF_WheelSpeedRpt__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  WheelSpeedRpt_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double front_left_wheel_speed_;
                ::DDS::Double front_right_wheel_speed_;
                ::DDS::Double rear_left_wheel_speed_;
                ::DDS::Double rear_right_wheel_speed_;
            };

            typedef DDS_DCPSStruct_var<WheelSpeedRpt_> WheelSpeedRpt__var;
            typedef DDS_DCPSStruct_out < WheelSpeedRpt_> WheelSpeedRpt__out;

        }

    }

}

#endif /* _H_E136C125D7C85614837BB0FFCCF0E3EF_WheelSpeedRpt__H_ */
