#ifndef _H_E136C125D7C85614837BB0FFCCF0E3EF_WheelSpeedRpt_DCPS_H_
#define _H_E136C125D7C85614837BB0FFCCF0E3EF_WheelSpeedRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WheelSpeedRpt_.h"


namespace pacmod_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WheelSpeedRpt_TypeSupportInterface;

            typedef WheelSpeedRpt_TypeSupportInterface * WheelSpeedRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedRpt_TypeSupportInterface> WheelSpeedRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WheelSpeedRpt_TypeSupportInterface> WheelSpeedRpt_TypeSupportInterface_out;


            class WheelSpeedRpt_DataWriter;

            typedef WheelSpeedRpt_DataWriter * WheelSpeedRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedRpt_DataWriter> WheelSpeedRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < WheelSpeedRpt_DataWriter> WheelSpeedRpt_DataWriter_out;


            class WheelSpeedRpt_DataReader;

            typedef WheelSpeedRpt_DataReader * WheelSpeedRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedRpt_DataReader> WheelSpeedRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < WheelSpeedRpt_DataReader> WheelSpeedRpt_DataReader_out;


            class WheelSpeedRpt_DataReaderView;

            typedef WheelSpeedRpt_DataReaderView * WheelSpeedRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedRpt_DataReaderView> WheelSpeedRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WheelSpeedRpt_DataReaderView> WheelSpeedRpt_DataReaderView_out;

            struct WheelSpeedRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < WheelSpeedRpt_, struct WheelSpeedRpt_Seq_uniq_> WheelSpeedRpt_Seq;
            typedef DDS_DCPSSequence_var < WheelSpeedRpt_Seq> WheelSpeedRpt_Seq_var;
            typedef DDS_DCPSSequence_out < WheelSpeedRpt_Seq> WheelSpeedRpt_Seq_out;

            class  WheelSpeedRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WheelSpeedRpt_TypeSupportInterface_ptr _ptr_type;
                typedef WheelSpeedRpt_TypeSupportInterface_var _var_type;

                static WheelSpeedRpt_TypeSupportInterface_ptr _duplicate (WheelSpeedRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WheelSpeedRpt_TypeSupportInterface () {};
                ~WheelSpeedRpt_TypeSupportInterface () {};
            private:
                WheelSpeedRpt_TypeSupportInterface (const WheelSpeedRpt_TypeSupportInterface &);
                WheelSpeedRpt_TypeSupportInterface & operator = (const WheelSpeedRpt_TypeSupportInterface &);
            };

            class  WheelSpeedRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WheelSpeedRpt_DataWriter_ptr _ptr_type;
                typedef WheelSpeedRpt_DataWriter_var _var_type;

                static WheelSpeedRpt_DataWriter_ptr _duplicate (WheelSpeedRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WheelSpeedRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WheelSpeedRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WheelSpeedRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WheelSpeedRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WheelSpeedRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WheelSpeedRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WheelSpeedRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WheelSpeedRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WheelSpeedRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WheelSpeedRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WheelSpeedRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedRpt_& instance_data) = 0;

            protected:
                WheelSpeedRpt_DataWriter () {};
                ~WheelSpeedRpt_DataWriter () {};
            private:
                WheelSpeedRpt_DataWriter (const WheelSpeedRpt_DataWriter &);
                WheelSpeedRpt_DataWriter & operator = (const WheelSpeedRpt_DataWriter &);
            };

            class  WheelSpeedRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WheelSpeedRpt_DataReader_ptr _ptr_type;
                typedef WheelSpeedRpt_DataReader_var _var_type;

                static WheelSpeedRpt_DataReader_ptr _duplicate (WheelSpeedRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelSpeedRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelSpeedRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelSpeedRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedRpt_& instance) = 0;

            protected:
                WheelSpeedRpt_DataReader () {};
                ~WheelSpeedRpt_DataReader () {};
            private:
                WheelSpeedRpt_DataReader (const WheelSpeedRpt_DataReader &);
                WheelSpeedRpt_DataReader & operator = (const WheelSpeedRpt_DataReader &);
            };

            class  WheelSpeedRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WheelSpeedRpt_DataReaderView_ptr _ptr_type;
                typedef WheelSpeedRpt_DataReaderView_var _var_type;

                static WheelSpeedRpt_DataReaderView_ptr _duplicate (WheelSpeedRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelSpeedRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelSpeedRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelSpeedRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelSpeedRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedRpt_& instance) = 0;

            protected:
                WheelSpeedRpt_DataReaderView () {};
                ~WheelSpeedRpt_DataReaderView () {};
            private:
                WheelSpeedRpt_DataReaderView (const WheelSpeedRpt_DataReaderView &);
                WheelSpeedRpt_DataReaderView & operator = (const WheelSpeedRpt_DataReaderView &);
            };
        }

    }

}

#endif
